# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================


#=========================================================================================
"""
    Classe grant les fiches bio
    Classe drives: Bio_add, Bio_mod, Bio_show, Bio_search,Bio_classif
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

from xml.dom.minidom import parse, getDOMImplementation
from xml.dom.ext import PrettyPrint

from Tkinter import *
import Pmw,re,os
import tools,dialog,mysql,progress,copy

try:
     from PIL import Image, ImageTk
except ImportError:
     import Image, ImageTk



class Bio:
    """
    Classe grant les fiches bio
    Classe drives: Bio_fiche, Bio_classif
    """

    def __init__(self,top,gui):
        self.top=top
        self.gui=gui
        self.fullwindow=False           # fenetre pleine cran ou onlget
        self.file='./classif.xml'
        self.db=mysql.Mysql(gui.config,self.top)
        self.N1=None                    # Nom du premier niveau de classification
        self.N3=None                    # Nom du second niveau de classification
        self.N3=None                    # Nom du troisieme niveau de classification
        self.classif={}                 # dictionnaire contenant la classification
        self.N1ordone=[]                # Premier niveau de classification (ordonn)        
        self.Lire()

    def Lire(self):
        """
        Lit le fichier de classification
        """
        try:
            dom = parse(self.file)
            top_element=dom.childNodes[0]
        except Exception, error:
            msg="Fichier de classification '"+str(self.file)+"' illisible !\n"+str(error)
            dialog.Errormsg(self.top,msg).show()
        if top_element.tagName != "GrubsClassif" :
            dialog.Errormsg(self.top,
                           "Fichier de classification '"+str(self.file)+"' illisible !").show()
        else:
            niveau=top_element.getElementsByTagName("Niveaux")[0]
            self.N1=niveau.getAttribute("N1")
            self.N2=niveau.getAttribute("N2")
            self.N3=niveau.getAttribute("N3")
            Niveau1=niveau.getElementsByTagName("N1")
            for niv1 in Niveau1:
                Niveau2=niv1.getElementsByTagName("N2")
                dicn2={}
                for niv2 in Niveau2:
                    listn3=[]
                    Niveau3=niv2.getElementsByTagName("N3")
                    for niv3 in Niveau3:
                        listn3.append(niv3.childNodes[0].nodeValue)
                    dicn2[niv2.getAttribute("Name")]=listn3
                self.classif[niv1.getAttribute("Name")]=dicn2
                self.N1ordone.append(niv1.getAttribute("Name"))


    def Fermer(self):
        """
        Ferme l'onglet
        """
        if self.fullwindow:
            self.top.destroy()
        else:
            self.gui.Fermer()

    def FermerPopup(self,*e):
        """
        Ferme le popup menu du click droit
        """        
        self.popup.destroy()

    def Menu(self):
        """
        Affiche le menu de la page
        """
        self.menu=Frame(self.top)
        self.menu.pack(side='top',fill='x',expand='no')
        b = Button(self.menu,relief="flat", text='Fermer',compound='left',
			image=self.gui.pixmap['fermer'],
			command=self.Fermer,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)


class Bio_classif(Bio):
    """
    Classe grant la modification de la classification
    """
            
    def Menu(self):
        """
        Affiche le menu de la page
        """
        Bio.Menu(self)	
	b = Button(self.menu,relief="flat", text='Sauver',compound='left',
			image=self.gui.pixmap['sauver'],
			command=self.Ecrire,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)

    def Recharger(self):
        self.menu.destroy()
        self.win.destroy()
        self.Afficher()

    def Afficher(self):
        self.Menu()
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side='top',expand='yes',fill='y')
        self.win.component('frame').pack(expand='yes')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side='top',expand='yes',fill='both',padx=5,pady=5)
        l=Label(self.frame,
                text="Attention: Rglages rservs  un publique avertit !"+\
                "\nToute modification doit tre cohrent avec la base de donne MySQL!",
                fg='#0000AA',font=self.gui.config.police_b,bg='red')
        l.pack(side='top',anchor='nw',expand='yes',fill='both',padx=0)
        for niv1 in self.N1ordone:
                niveau1=niv1
                f=Frame(self.frame)
                f.pack(side="top",expand='yes',padx=0,pady=10,anchor='w',fill="none")
                l=Label(f,text=niveau1, anchor='w', justify='left',padx=10,
                        font=self.gui.config.police_b,
                        image=self.gui.pixmap['niv1'],compound='left')
                l.pack(side="top",expand="no",fill="both")
                l.bind("<ButtonPress-3>",
                       lambda event,niv=1,nom=niveau1,dico=self.classif:\
                              self.PopupMenu(event,nom,dico,niv))
                curniv2=0
                for niv2 in self.classif[niveau1].keys():
                        niveau2=self.classif[niveau1][niv2]
                        l=Label(f,height=5,anchor='w', justify='right',padx=0,pady=0,
                                image=self.gui.pixmap['nivvide'],)
                        l.pack(side="top",expand="no",fill="both",anchor='w')
                        l=Label(f,text=niv2.encode('latin-1'),height=34,
                                anchor='w', justify='right',padx=0,pady=0,
                                font=self.gui.config.police_n,
                                image=self.gui.pixmap['niv2'],compound='left')
                        l.pack(side="top",expand="no",fill="both",anchor='w')
                        l.bind("<ButtonPress-3>",
                               lambda event,niv=2,dico=self.classif[niveau1],nom=niv2:\
                                      self.PopupMenu(event,nom,dico,niv))
                        curniv2=curniv2+1
                        if curniv2==len(self.classif[niveau1]):
                                image=self.gui.pixmap['niv3']
                        else:
                                image=self.gui.pixmap['niv3v']
                        for niv3 in range(len(niveau2)):
                                niveau3=self.classif[niveau1][niv2][niv3]
                                l=Label(f,text=niveau3.encode('latin-1'),
                                        anchor='w', justify='left',height=34,padx=0,pady=0,
                                        font=self.gui.config.police_i,
                                        image=image,compound='left')
                                l.pack(side="top",expand="no",fill="both",anchor='w')
                                l.bind("<ButtonPress-3>",
                                       lambda event,niv=3,dico=self.classif[niveau1][niv2],
                                              nom=niveau3,:\
                                              self.PopupMenu(event,nom,dico,niv))

    def PopupMenu(self,e,nom,dico,niv):
        """
        Definit le Popum menu du click droit
        """
        self.popup=Menu(self.top,tearoff=0)
        if niv<=2:
            self.popup.add_command(label="Ajouter",command=lambda dico=dico[nom],
                                   niv=niv:self.AddNiv(dico,niv))
	if niv>=2:
            self.popup.add_command(label="Editer",command=lambda nom=nom,dico=dico,
                                   niv=niv:self.EditNiv(nom,dico,niv))
            self.popup.add_command(label="Supprimer",command=lambda nom=nom,dico=dico,
                                   niv=niv:self.DelNiv(nom,dico,niv))        
        self.popup.post(e.x_root-5,e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    
    def DelNiv(self,nom,dico,niv):
        q=dialog.Question(self.top,
                         "Supprimer le niveau de classification :"\
                         +str(nom.encode('latin-1'))+" ?")
        q.show()
        if bool(q.result):
            if niv==2:
                del dico[nom]
                self.Recharger()
            elif niv==3:
                del dico[dico.index(nom)]
                self.Recharger()

    def EditNiv(self,nom,dico,niv):
        msg='Nouveau nom pour '+str(nom.encode('latin-1'))+' ?'
        d=dialog.Input(self.top,msg)
        d.show()
        if d.result==1:
            if niv==2:
                if d.input not in dico.keys():
                    dico[d.input]=dico[nom]
                    del dico[nom]
                    self.Recharger()
                else:
                    msg="Ce niveau de classifiation existe dja !"
                    dialog.Errormsg(self.top,msg).show()

            elif niv==3:
                if d.input not in dico:
                    dico[dico.index(nom)]=d.input
                    self.Recharger()			    
                else:
                    msg="Ce niveau de classifiation existe dja !"
                    dialog.Errormsg(self.top,msg).show()
                    
    def AddNiv(self,dico,niv):
        msg='Nom du Niveau '+str(niv+1)+' de classification  ajouter ?'
        d=dialog.Input(self.top,msg)
        d.show()
        if d.result==1:
            if niv==1:
                if d.input not in dico.keys():
                    dico[d.input]=[]
                    self.Recharger()
                else:
                    msg="Ce niveau de classifiation existe dja !"
                    dialog.Errormsg(self.top,msg).show()
            elif niv==2:
                if d.input not in dico:
                    dico.append(d.input)
                    self.Recharger()				    
                else:
                    msg="Ce niveau de classifiation existe dja !"
                    dialog.Errormsg(self.top,msg).show()
        
    def Ecrire(self):
        dom = getDOMImplementation()
        doc = dom.createDocument(None, "GrubsClassif", None)
        Node = doc.documentElement
        niveaux= doc.createElement("Niveaux")
        Node.appendChild(niveaux)
        niveaux.setAttribute("N1",self.N1)
        niveaux.setAttribute("N2",self.N2)
        niveaux.setAttribute("N3",self.N3)
        for niv1 in self.N1ordone:
                n1=doc.createElement("N1")
                niveaux.appendChild(n1)
                niveau1=niv1
                n1.setAttribute("Name",niveau1)
                for niv2 in self.classif[niveau1].keys():
                        niveau2=self.classif[niveau1][niv2]
                        n2=doc.createElement("N2")
                        n1.appendChild(n2)
                        n2.setAttribute("Name",niv2)
                        for niv3 in range(len(niveau2)):
                                niveau3=self.classif[niveau1][niv2][niv3]
                                n3=doc.createElement("N3")
                                n2.appendChild(n3)
                                n3.appendChild(doc.createTextNode(niveau3))
        import shutil
        shutil.copyfile(self.file, "%s.bak" % self.file)
        fid=open(self.file,"w")
        PrettyPrint(doc, fid)
        fid.close()
        dialog.Info(self.top, msg="La nouvelle classification a t sauvegarde\n"+
                   "Redmarez l'application pour prendre en compte les modifications\n"+
                   "(L'ancien fichier a t copi dans: %s.bak" % self.file).show()
        self.Fermer()


class Bio_Fiche(Bio):
    """
    Classe grant les fiches bio
    """

    def __init__(self,top,gui,id=None):
        Bio.__init__(self,top,gui)
        self.id=id
        self.niveau1=StringVar()
        self.niveau2=StringVar()
        self.niveau3=StringVar()
        self.commun=StringVar()
        self.latin=StringVar()
        self.autre=StringVar()
        self.comment=None
        self.tri=None

    def LireFiche(self):
        """
        Charge la fiche bio de la base de donne
        """        
        champs=['commun','latin','autre','comment','embranchement','classe','espece']
        condition="ID='"+str(self.id)+"'"
        res=self.db.select('bio',champs,condition)
        self.commun.set(res[0][0])
        self.latin.set(res[0][1])
        self.autre.set(res[0][2])
        self.comment=StringVar()
        self.comment.set(res[0][3])
        self.niveau1.set(res[0][4])
        self.niveau2.set(res[0][5])
        self.niveau3.set(res[0][6])

    def Menu(self,actions):
        Bio.Menu(self)
        if 'vider' in actions:
            b = Button(self.menu,relief="flat", text='Vider',compound='left',
                    image=self.gui.pixmap['vider'],
                    command=self.Vider,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'sauver' in actions:
            b = Button(self.menu,relief="flat", text='Sauver',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Sauver,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'rechercher' in actions:
            b = Button(self.menu,relief="flat", text='Rechercher',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Rechercher,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'supprimer' in actions:
            b = Button(self.menu,relief="flat", text='Supprimer',compound='left',
                    image=self.gui.pixmap['supprimer'],
                    command=lambda id=self.id :self.SupprimerFiche(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'modifier' in actions:
            b = Button(self.menu,relief="flat", text='Editer',compound='left',
                    image=self.gui.pixmap['editer'],
                    command=lambda id=self.id :self.ModifierFiche(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)

    def Sauver(self):
        pass

    def Vider(self):
        self.niveau1.set('')
        self.niveau2.set('')
        self.niveau3.set('')
        self.commun.set('')
        self.latin.set('')
        self.autre.set('')
        pass

    def SupprimerFiche(self,id):
        q=dialog.Question(self.top,"\nSupprimer la Fiche Bio "+str(id)+" ? \n")
        q.show()
        if bool(q.result):
            res=self.db.SupprimerBio(id)
            if res!='error':
                dialog.Info(self.top,"La fiche bio "+str(id)+" a t supprime\n").show()
        else:
            pass
        return q.result

    def ModifierFiche(self,id):
        self.gui.ModifierBio(id)

    def AfficherFiche(self,id):
        self.gui.AfficherBio(id)

    def FormClassif(self,top):
        """
        Affiche le formulaire de selection d'une branche de la classification
        """
        self.formclassif=Pmw.Group(top,tag_text='Classification',tag_font=self.gui.config.police_i)
        self.formclassif.pack(side='top',padx=5,pady=5,expand='yes',anchor='e',fill='both')
        self.FormN1()
        self.FormN2(self.niveau2)
        self.FormN3(self.niveau3)

    def FormN1(self):
        """
        Formulaire pour le niveau 1 de classification
        """
        self.FormN3Del()
        self.FormN2Del()
        self.FormN1Del()
        self.FormNomReset()
        niv1list=self.N1ordone
        if self.tri is not None:
            niv1list.append('Tous')
        self.formniveau1=Pmw.OptionMenu(self.formclassif.interior(), 
                         menubutton_textvariable = self.niveau1,
                         labelpos = 'w',label_text = self.N1+' : ',
                         items = niv1list, menubutton_width = 10, label_width=15,
                         command=lambda texte=self.niveau1 :self.FormN2(texte),)
        self.formniveau1.component('label').config(anchor='e')
        self.formniveau1.component('menubutton').config(padx=5,pady=3,width=15)
        self.formniveau1.pack(side="top",anchor = 'w', padx = 3, pady = 3,fill="both")

    def FormN2(self,texte):
        """
        Formulaire pour le niveau 2 de classification:
        """
        self.FormN2Del()
        self.FormN3Del()
        self.FormNomReset()
        if self.niveau1.get() not in ['','Tous']:
            niv2list=self.classif[self.niveau1.get()].keys()
            if self.tri is not None:
                niv2list.append('Tous')
            if self.niveau2.get() not in niv2list:
                self.niveau2.set('')
        else:
             self.niveau2.set('')
             niv2list=[]
        if len(niv2list)==0 or niv2list==['Tous']:
            self.FormN3(self.niveau2)	
        else:
            if len(niv2list)==1:
                self.niveau2.set(niv2list[0])
            self.formniveau2 = Pmw.OptionMenu(self.formclassif.interior(), 
                               menubutton_textvariable = self.niveau2,
                               labelpos = 'w',label_text = self.N2+' : ',
                               items = niv2list, menubutton_width = 10, label_width=15,
                               command=lambda texte=self.niveau2 :self.FormN3(texte))
            self.formniveau2.component('label').config(anchor='e')
            self.formniveau2.component('menubutton').config(padx=5,pady=3,width=15)
            self.formniveau2.pack(side="top",anchor = 'e', padx = 3, 
                                  pady = 3, fill="both")

    def FormN3(self,texte):
        """
        Formulaire pour le niveau 3 de classification:
        """
        self.FormN3Del()
        self.FormNomReset()
        if self.niveau2.get() not in ['','Tous']:
            niv3list=copy.copy(self.classif[self.niveau1.get()][self.niveau2.get()])
            if self.tri is not None:
                niv3list.append('Tous')
            if self.niveau3.get() not in niv3list:
                self.niveau3.set('')
        else:
            self.niveau3.set('')
            niv3list=[]
        if len(niv3list)==0 or niv3list==['Tous']:
            pass
        else:
            if len(niv3list)==1:self.niveau3.set(niv3list[0])
            self.formniveau3 = Pmw.OptionMenu(self.formclassif.interior(), 
                               menubutton_textvariable = self.niveau3,label_width=15,
                               labelpos = 'w',label_text = self.N3+' : ',
                               items = niv3list,menubutton_width = 15,
                               command=self.FormNomReset)
            self.formniveau3.component('label').config(anchor='e')
            self.formniveau3.component('menubutton').config(padx=5,pady=3,width=15)
            self.formniveau3.pack(side="top",anchor = 'w', padx = 3, pady = 3,fill="both")

    def FormN1Del(self):
        try:
            self.formniveau1.pack_forget()
        except:
            pass
        
    def FormN2Del(self):
        try:
            self.formniveau2.pack_forget()
        except:
            pass

    def FormN3Del(self):
        try:
            self.formniveau3.pack_forget()
        except:
            pass

    def FormNomReset(self,*e):
        pass

    def FormNom(self,top):
        """
        Formulaire pour les Noms:
        """
        self.formnom=Pmw.Group(top,tag_text='Noms',tag_font=self.gui.config.police_i)
        self.formnom.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        f=Frame(self.formnom.interior())
        f.pack(side="top",expand='yes',padx=5,pady=5,anchor='w',fill="both")
        # nom commun
        e=Pmw.EntryField(f,labelpos='w',label_text='Vernaculaire : ',
                         entry_textvariable=self.commun)
        e._entryFieldEntry.grid( sticky = 'w' )
        e._entryFieldEntry.config( width = '20' )
        e.pack(side="right",fill="both",expand="yes",padx=3,pady=3)
        #nom latin
        e=Pmw.EntryField(f,labelpos='w',label_text='Latin : ',
                         entry_textvariable=self.latin,)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = '20' )
        e.pack(side="left",fill="both",expand="yes",padx=3,pady=3)
        # autres noms
        f=Frame(self.formnom.interior())
        f.pack(side="top",expand='yes',padx=5,pady=5,anchor='w',fill="both")
        e=Pmw.EntryField(f,labelpos='w',label_text='Autres noms courants : ',
                         entry_textvariable=self.autre, )
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = '40' )
        e.pack(side="right",fill="both",expand="yes",padx=3,pady=3)

    def FormComment(self,top):
        self.formcomment=Pmw.Group(top,tag_text='Commentaires',tag_font=self.gui.config.police_i)
        self.formcomment.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")          

class Bio_Fiche_Ajouter(Bio_Fiche):
    """
    Classe d'ajout des fiches bio
    """
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='n',
                    fill='both', padx = 0, pady = 0)
        self.hg=Frame(self.h)
        self.hg.pack(side="left",expand='yes',anchor='n',
                     fill='both', padx = 5, pady = 5)
        self.hd=Frame(self.h)
        self.hd.pack(side="left",expand='yes',anchor='n',
                     fill='both', padx = 5, pady = 5)
        self.b=Frame(self.frame)
        self.b.pack(side="top",expand='yes',anchor='n',
                    fill='both', padx = 5, pady = 5)        

    def Afficher(self):
        self.Menu(['sauver','vider'])
        self.MiseEnPage()
        self.FormClassif(self.hg)
        self.FormNom(self.hd)
        self.FormComment(self.b)

    def FormComment(self,top):
        Bio_Fiche.FormComment(self,top)
        if self.comment is not None:
            comment=self.comment.get()
        else:
            comment=''
        self.comment=Pmw.ScrolledText(self.formcomment.interior(),text_padx = 4,text_pady = 4,
                                      usehullsize = 1,hull_width = 600,hull_height = 150)
        self.comment.pack(side="top",padx=5,pady=5)
        self.comment.settext(comment)
        
    def Vider(self):
        Bio_Fiche.Vider(self)
        self.comment.settext('')
        self.FormN1()
        
    def Sauver(self,Modifier=False):
        go_on=True
        if self.niveau1.get() =='':
            e=dialog.Errormsg(self.top,"Choisissez au moins un embranchement !")
            e.show()
            go_on=False
        else:
            exist,id=self.db.ElementExist('bio',"latin=\""+tools.nettoyer(self.latin.get())+"\"")
            if exist and not Modifier:
                q=dialog.Question(self.top,"Une fiche avec le mme nom latin existe dj"+\
                                  "Souhaitez vous la remplacer ?")
                q.show()
                if q.result:
                    self.id=id
                    Modifier=True
                else:
                    go_on=False
        if go_on:
            elements=[]
            elements.append('latin="'+tools.nettoyer(self.latin.get())+'"')
            elements.append('autre="'+tools.nettoyer(self.autre.get())+'"')
            elements.append('embranchement="'+tools.nettoyer(self.niveau1.get())+'"')
            elements.append('classe="'+tools.nettoyer(self.niveau2.get())+'"')
            elements.append('espece="'+tools.nettoyer(self.niveau3.get())+'"')
            elements.append('comment="'+tools.add_br(self.comment.get())+'"')
            elements.append('commun="'+tools.nettoyer(self.commun.get())+'"')
            if not Modifier:
                res,id=self.db.ajouter('bio',elements)
            else:
                res=self.db.modifier('bio',elements,str(self.id))
            if res!='error':
                try:
                    msg="La fiche: "+str(self.latin.get().encode('latin-1'))+" a t ajoute"
                except:
                    msg="La fiche: "+str(self.latin.get())+" a t ajoute"
                i=dialog.Info(self.top,msg)                  
                i.show()
        
        
class Bio_Fiche_Rechercher(Bio_Fiche):
    """
    Classe de recherche de fiches bio
    """
    def __init__(self,top,gui):
        Bio_Fiche.__init__(self,top,gui,None)
        self.tri='commun'
        self.comment=StringVar()
        self.avancement=None
        
    def MiseEnPage(self):
        self.win=Pmw.PanedWidget(self.top,orient='vertical')
        self.win.pack(side="top",fill="both",expand="yes")
        self.win.add('recherche',min=0)
        self.win.add('resultat',min=0)
        self.h=Pmw.ScrolledFrame(self.win.pane("recherche"))
        self.h.pack(side="top",expand="yes",fill="none")
        self.h.component('frame').pack(expand='yes')
        self.hg=Frame(self.h.interior())
        self.hg.pack(side='left',expand='yes',fill='x')
        self.hd=Frame(self.h.interior())
        self.hd.pack(side='left',expand='yes',fill='x')
        self.b=None

    def Afficher(self):
        self.Menu(['rechercher','vider'])
        self.MiseEnPage()
        self.formnom=Pmw.Group(self.hd,tag_text='Noms',tag_font=self.gui.config.police_i)
        self.formnom.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        self.FormNom(self.formnom.interior())
        self.FormText(self.hd)
        self.FormClassif(self.hg)

    def FormNom(self,top,side='right'):
        """
        Formulaire de recherche nom
        """
        self.formnom_interior=Frame(top)
        self.formnom_interior.pack(side='top',expand='yes',padx=5,pady=5,anchor='w',fill="both")
        listcommun,listlatin=self.db.getNoms(self.niveau1.get(),self.niveau2.get(),self.niveau3.get())
        self.formcommun=Pmw.ComboBox(self.formnom_interior,label_text = 'Commun:',labelpos = 'w',
                                     selectioncommand = self.DropdownCommun,label_width=7,
                                     scrolledlist_items = listcommun,
                                     history=0)
        self.formcommun.component('entry').config(width=25)
        self.formcommun.pack(side=side,fill="both",expand="yes",padx=3,pady=3)
        self.formlatin=Pmw.ComboBox(self.formnom_interior,label_text = 'Latin:',labelpos = 'w',
                                    selectioncommand = self.DropdownLatin,label_width=7,
                                    scrolledlist_items = listlatin,
                                    history=0)
        self.formlatin.component('entry').config(width=25)        
        self.formlatin.pack(side=side,fill="both",expand="yes",padx=3,pady=3)

    def FormNomReset(self,*e):
        listcommun,listlatin=self.db.getNoms(self.niveau1.get(),self.niveau2.get(),self.niveau3.get())
        commun=self.formcommun.get()
##        self.formnom_interior.pack_forget()
##        self.FormNom(self.formnom.interior())
        self.formcommun.clear()
        self.formcommun.component('scrolledlist').setlist(listcommun)
        self.formlatin.clear()
        self.formlatin.component('scrolledlist').setlist(listlatin)
        if commun in listcommun:
            self.formcommun.selectitem(commun)
            self.DropdownCommun(commun)

    def DropdownCommun(self,commun):
        self.commun.set(commun)
        try:
            index=self.formcommun.component('listbox').index('active')
            self.formlatin.selectitem(index)
        except:
            self.formlatin.selectitem('')
  
    def DropdownLatin(self,latin):
        self.latin.set(latin)
        try:
            index=self.formlatin.component('listbox').index('active')
            self.formcommun.selectitem(index)
        except:
            self.formcommun.selectitem('')

    def FormText(self,top):
        self.formcomment=Pmw.Group(top,tag_text='Text',tag_font=self.gui.config.police_i)
        self.formcomment.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        f=Frame(self.formcomment.interior())
        f.pack(side="top",expand='yes',padx=5,pady=5,anchor='w',fill="both")
        e=Pmw.EntryField(f,labelpos='w',label_text='Contient : ',
                         entry_textvariable=self.comment, )
        e._entryFieldEntry.grid( sticky = 'w' )
        e._entryFieldEntry.config( width = '45' )
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3)
        l=Label(f,text='(wildcard: %)')
        l.pack(side="left",anchor='w',expand='no',fill='none')

    def Vider(self):
        Bio_Fiche.Vider(self)
        self.comment.set('')
        self.FormN1()
        try:
            self.b.destroy()
        except:
            pass

    def Rechercher(self,Afficher=True):
        if self.avancement is None:
            champs=['ID','commun','latin','embranchement','classe','espece','autre']
            condition='(1 '
            if self.niveau1.get() not in ['','Tous']:
                condition+=" AND embranchement='"+tools.nettoyer(self.niveau1.get())+"'"
            if self.niveau2.get() not in ['','Tous']:
                condition+=" AND classe ='"+tools.nettoyer(self.niveau2.get())+"'"
            if self.niveau3.get() not in ['','Tous']:
                condition+=" AND espece ='"+tools.nettoyer(self.niveau3.get())+"'"
            if self.commun.get() != '':
                condition+=" AND commun='"+tools.nettoyer(self.commun.get())+"'"
            if self.latin.get() != '':
                condition+=" AND latin='"+tools.nettoyer(self.latin.get())+"'"
            condition+=') '
            text=self.comment.get()
            if len(text)>3:
                condition+=" AND (comment LIKE '%"+tools.nettoyer(text)+"%'"
                if self.niveau1.get() in ['','Tous']:
                    condition+=" OR embranchement LIKE '%"+tools.nettoyer(text)+"%'"
                if self.niveau2.get() in ['','Tous']:
                    condition+=" OR classe LIKE '%"+tools.nettoyer(text)+"%'"
                if self.niveau3.get() in ['','Tous']:
                    condition+=" OR espece LIKE '%"+tools.nettoyer(text)+"%'"
                if self.latin.get() in ['','Tous']:
                    condition+=" OR latin LIKE '%"+tools.nettoyer(text)+"%'"
                if self.commun.get() in ['','Tous']:
                    condition+=" OR commun LIKE '%"+tools.nettoyer(text)+"%'"
                condition+=' ) '
            condition+=" ORDER BY "+self.tri
            res=self.db.select('bio',champs,condition)
            if Afficher:
                self.Resultat(res)
            else:
                idbio=[]
                for item in range(len(res)):
                    idbio.append(str(res[item][0]))
                return idbio

    def CriteresBio(self):
        """
        retourne True si des criteres bio sont selectionns pour la recherche
        """
        if (self.niveau1.get() not in ['','Tous'] or\
            self.niveau2.get() not in ['','Tous'] or\
            self.niveau3.get() not in ['','Tous'] or\
            self.commun.get() != '' or\
            self.latin.get() != '' or\
            len(self.comment.get()) >=3):
            return True
        else:
            return False
           

    def Resultat(self,res):
        nbres=len(res)
        go_on=True
        if nbres>100:
            q=dialog.Question(self.top,
                         "Plus de 100 resultats trouvs ("+str(nbres)+")"\
                         +"\nL'affichage risque d'etre trs fortement ralenti"\
                         +"\n Souhaitez vous tout de mme afficher les rsultat ?")
            q.show()
            if bool(q.result):
                go_on=True
            else:
                go_on=False
        if go_on:
            if self.b is not None:
                self.b.pack_forget()
            self.b=Pmw.ScrolledFrame(self.win.pane("resultat"),labelpos = 'n',
                                     label_text = str(nbres)+" rsultat(s) trouvs",
                                     label_foreground='red',label_font=self.gui.config.police_b,)
            self.b.component('frame').pack(expand='yes')
            self.b.pack(side="top",expand="yes",fill="y")
            #en tete colonnes
            col=['ID','Nom commun','Nom latin',self.N1,self.N2,self.N3]
            colwidth=[4,30,30,17,17,17]
            f=Frame(self.b.interior())
            f.pack(side="top",expand="yes",fill="both")
            for item in range(0,len(col)):
                l=Label(f,text=col[item], anchor=W, justify=LEFT,
                        width=colwidth[item],bg='#EEEEEE',
                        fg="blue",font=self.gui.config.police_b)
                l.pack(side="left",expand="yes",fill="both")
                l.bind("<ButtonPress-1>",
                       lambda event,tri=col[item]:self.Trier(event,tri))
            # bar de progression
            self.avancement=progress.ProgressBar(self.top)
            #remplissage colonnes
            for item in range(nbres):
                avance=float(item+1)/(nbres)*100
                self.avancement.SetProgressPercent(avance)
                self.top.update()
                f=Frame(self.b.interior())
                f.pack(side="top",expand="yes",fill="both")
                if item%2==0:
                    color="#CCCCCC"
                else:
                    color="#DDDDDD"
                for lab in range(0,len(col)):
                    l=Label(f,text=res[item][lab], anchor=W, justify=LEFT,
                            width=colwidth[lab],bg=color,
                            font=self.gui.config.police_n)
                    l.pack(side="left",expand="yes",fill="both")
                    l.bind("<ButtonPress-3>",
                           lambda event,id=res[item][0]:self.PopupMenu(event,id))
                    if nbres<100:
                        #au dessus de 100 resultat les balloon font ramer l'appli !
                        txt=   "ID              :"+str(res[item][0])
                        txt+="\nEmbranchement   :"+str(res[item][3])
                        txt+="\nClasse          :"+str(res[item][4])
                        txt+="\nOrdre, espce...:"+str(res[item][5])
                        txt+="\nNom commun      :"+str(res[item][1])
                        txt+="\nNom latin       :"+str(res[item][2])
                        txt+="\nAutres noms     :"+str(res[item][6])
                        b=Pmw.Balloon(self.top)
                        b.bind(l,txt)
                        b.component('label').config(font=('Courrier',14,'normal'))
            self.avancement.destroy()
            self.avancement=None

    def PopupMenu(self,e,id):
        if self.avancement is None:
            self.popup=Menu(self.top,tearoff=0)
            self.popup.add_command(label="Afficher",command=lambda item=id:self.AfficherFiche(item))
            self.popup.add_command(label="Modifier",command=lambda item=id:self.ModifierFiche(item))
            self.popup.add_command(label="Supprimer",command=lambda item=id:self.SupprimerFiche(item))
            self.popup.post(e.x_root-5,e.y_root-5)
            self.popup.bind("<Leave>",self.FermerPopup)

    def Trier(self,event,tri):
        if self.avancement is None:
            if tri=='Nom commun':
                self.tri='commun'
            elif tri=='Nom latin':
                self.tri='latin'
            elif tri==self.N1:
                self.tri='embranchement'
            elif tri==self.N2:
                self.tri='classe'
            elif tri==self.N3:
                self.tri='espece'
            self.Rechercher()
            
    def Fermer(self):
        if self.avancement is None:
            Bio.Fermer(self)

class Bio_Fiche_Afficher(Bio_Fiche):
    """
    Classe d'affichage des fiches bio
    """
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='n',
                    fill='both', padx = 0, pady = 0)
        self.hg=Frame(self.h)
        self.hg.pack(side="left",expand='yes',anchor='n',
                     fill='both', padx = 5, pady = 5)
        self.hd=Frame(self.h)
        self.hd.pack(side="left",expand='yes',anchor='n',
                     fill='both', padx = 5, pady = 5)
        self.b=Frame(self.frame)
        self.b.pack(side="top",expand='yes',anchor='n',
                    fill='both', padx = 5, pady = 5) 
        
    def Afficher(self):
        self.Menu(['modifier','supprimer'])
        self.MiseEnPage()
        self.LireFiche()
        self.AfficherClassif()
        self.AfficherNom()
        self.AfficherComment()
        self.AfficherPhoto()

    def AfficherClassif(self):
        g=Pmw.Group(self.hg,tag_text='Classification',tag_font=self.gui.config.police_i)
        g.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='e',fill='both')
        f=Frame(g.interior())
        f.pack(side="top",expand="yes",fill="both",padx=5,pady=5)
        l=Label(f,text=self.N1+" : ", anchor='e', justify='right',font=self.gui.config.police_b,width=15,)
        l.pack(side="left",expand="yes",fill="both")
        l=Label(f,text=self.niveau1.get(), anchor='w', justify='left',width=20)
        l.pack(side="left",expand="yes",fill="both")
        if self.niveau2.get()!='':
            f=Frame(g.interior())
            f.pack(side="top",expand="yes",fill="both")
            l=Label(f,text=self.N2+" : ", anchor='e', justify='right',
                    font=self.gui.config.police_b,width=15,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(f,text=self.niveau2.get(), anchor='w', justify='left',width=20)
            l.pack(side="left",expand="yes",fill="both")
        if self.niveau3.get()!='':
            f=Frame(g.interior())
            f.pack(side="top",expand="yes",fill="both")
            l=Label(f,text=self.N3+" : ", anchor='e',justify='right',
                    font=self.gui.config.police_b,width=15,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(f,text=self.niveau3.get(), anchor='w', justify='left',width=20)
            l.pack(side="left",expand="yes",fill="both")

    def AfficherNom(self):
        labelwidth=18
        entrywidth=25
        wrapwidth=150
        g=Pmw.Group(self.hd,tag_text='Noms',tag_font=self.gui.config.police_i)
        g.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        if self.commun.get()!='':
            ff=Frame(g.interior())
            ff.pack(side="top",expand="yes",fill="both")
            l=Label(ff,text='Nom vernaculaire : ', anchor='e',
                    justify='right',font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(ff,text=self.commun.get(), anchor='w', justify='left',width=entrywidth,
                    wraplength=wrapwidth)
            l.pack(side="left",expand="yes",fill="both")
        if self.latin.get()!='':
            ff=Frame(g.interior())
            ff.pack(side="top",expand="yes",fill="both")
            l=Label(ff,text='Nom latin : ', anchor='e', justify='right',
                    font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(ff,text=self.latin.get(), anchor='w', justify='left',width=entrywidth,
                    wraplength=wrapwidth)
            l.pack(side="left",expand="yes",fill="both")        
        if self.autre.get()!='':
            ff=Frame(g.interior())
            ff.pack(side="top",expand="yes",fill="both")
            l=Label(ff,text='Autres : ', anchor='e', justify='right',
                    font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(ff,text=self.autre.get(), anchor='w', justify='left',width=entrywidth,
                    wraplength=wrapwidth)
            l.pack(side="left",expand="yes",fill="both")

    def AfficherComment(self):
        self.FormComment(self.b)
        text=self.comment.get()
        l=Pmw.ScrolledText(self.formcomment.interior(),usehullsize = 1,
                           hull_width = 730,hull_height=200,
                           text_wrap='word',text_bg='#DDDDDD',
                           )
        l.component('text').config(relief='flat')
        l.pack(side="left",expand="yes",fill="both",padx=10,pady=10)
        l.settext(re.sub('<br>','\n',text))
        tools.HTMLFormat(l.component('text'),self.gui.config.police_b,
                         self.gui.config.police_i,self.gui.config.police_u)

    def AfficherPhoto(self):
        idphoto=self.db.Bio2Photo([str(self.id)])
        labelwidth=eval(self.gui.config.mini_larg.get())+10
        labelheight=eval(self.gui.config.mini_haut.get())+10
        nb_mini=eval(self.gui.config.mini_nb.get())
        
        g=Pmw.Group(self.b,tag_text='Photos',tag_font=self.gui.config.police_i)
        g.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        f=Frame(g.interior(),padx=5,pady=5)
        f.pack(side="top",expand="yes",fill="x")        
        self.listemini=[]
        nb=1
        for item in idphoto:
            champs=['fichier','mer','pays','lieu','site','date']
            condition="ID='"+str(item)+"'"
            fichephoto=self.db.select('photo',champs,condition)
            if nb>nb_mini:
                f=Frame(top,padx=5,pady=5)
                f.pack(side="top",expand="yes",fill="x")
                nb=1
            chemin='./miniature/'+str(fichephoto[0][0])
            if not os.path.isfile(chemin):
                chemin='./pixmap/mininotfound.jpg'
            photo=Image.open(chemin)
            photo=ImageTk.PhotoImage(photo)
            self.listemini.append(photo)
            l=Label(f,image=photo,width=labelwidth,
                    height=labelheight,relief='raised')
            l.pack(side='left',padx = 10,
                   pady = 10,expand='no',anchor='w',fill="none")
            l.bind("<ButtonPress-3>",lambda event,idphoto=item:\
                                            self.PopupMenu(event,idphoto))
            txt=   "ID   :"+str(item)
            txt+="\nDate :"+tools.inverseDate(str(fichephoto[0][5])[:10])
            txt+="\nMer  :"+str(fichephoto[0][1])
            txt+="\nPays :"+str(fichephoto[0][2])
            txt+="\nLieu :"+str(fichephoto[0][3])
            txt+="\nSite :"+str(fichephoto[0][4])
            b=Pmw.Balloon(self.top)
            b.bind(l,txt)
            b.component('label').config(font=('Courrier',14,'normal'))
            nb+=1

    def PopupMenu(self,e,id):
        self.popup=Menu(self.top,tearoff=0)
        self.popup.add_command(label="Afficher",
                               command=lambda item=id:self.gui.AfficherPhoto(item))
        self.popup.add_separator()
        self.popup.add_command(label="Supprimer lien",
                               command=lambda item=id:self.SupprimerLien(item))
        self.popup.post(e.x_root-5,e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    def SupprimerLien(self,id):
        self.db.SupprimerLien(self.id,id)


class Bio_Fiche_Modifier(Bio_Fiche_Ajouter):
    """
    Classe de modification des fiches bio
    """
    def ConvertUnicode(self):
        try:
            self.niveau1.set(unicode(self.niveau1.get(),'latin-1'))
            self.niveau2.set(unicode(self.niveau2.get(),'latin-1'))
            self.niveau3.set(unicode(self.niveau3.get(),'latin-1'))
        except:
            pass

    def Afficher(self):
        self.LireFiche()
        self.ConvertUnicode()
        Bio_Fiche_Ajouter.Afficher(self)

    def Sauver(self):
        Bio_Fiche_Ajouter.Sauver(self,Modifier=True)

