# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    Classe dfinissant toute la configuration de l'application
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

from xml.dom.minidom import parse, getDOMImplementation
from xml.dom.ext import PrettyPrint
from Tkinter import *
import Pmw,os,dialog

class Config:
    """
    Classe dfinissant toute la configuration de l'application
    """

    def __init__(self,file,top,gui):
        """
        Definition des attributs et initialisation de la classe
        """
        self.top=top
        self.gui=gui
        self.file=file
        self.user=StringVar()
        self.host=StringVar()
        self.pwd=StringVar()
        self.db=StringVar()
        self.photo_copier=BooleanVar()
        self.photo_rep=StringVar()
        self.photo_larg=StringVar()
        self.photo_haut=StringVar()
        self.photo_comp=StringVar()
        self.mini_larg=StringVar()
        self.mini_haut=StringVar()
        self.mini_nb=StringVar()
        self.police=StringVar()
        self.police_taille=StringVar()
        
        self.Lire()

        self.police_i=(self.police.get(),int(self.police_taille.get()),'italic')
        self.police_b=(self.police.get(),int(self.police_taille.get()),'bold')
        self.police_bi=(self.police.get(),int(self.police_taille.get()),'bold italic')
        self.police_n=(self.police.get(),int(self.police_taille.get()),'normal')
        self.police_u=(self.police.get(),int(self.police_taille.get()),'underline')

    def Lire(self):
        """
        Lecture du fichier xml de configuration config.xml
        """
        try:
            dom = parse(self.file)
            top_element=dom.childNodes[0]
        except Exception, error:
            msg="Fichier de configuration '"+str(self.file)+"' illisible !\n"+str(error)
            dialog.Errormsg(self.top,msg).show()               
        if top_element.tagName != "GrubsConfig" :
            dialog.Errormsg(self.top, msg="Fichier de configuration '"+str(self.file)+"' illisible !").show()
        else:
            Node=top_element
            database=Node.getElementsByTagName("Database")[0]
            self.user.set(database.getAttribute("User"))
            self.pwd.set(database.getAttribute("Pwd"))
            self.host.set(database.getAttribute("Host"))
            self.db.set(database.getAttribute("db"))
        
            photo=Node.getElementsByTagName("Photo")[0]
            self.photo_copier.set(eval(photo.getAttribute("Copier")))
            self.photo_rep.set(photo.getAttribute("Rep"))
            self.photo_larg.set(photo.getAttribute("Larg"))
            self.photo_haut.set(photo.getAttribute("Haut"))
            self.photo_comp.set(photo.getAttribute("Comp"))

            mini=Node.getElementsByTagName("Mini")[0]
            self.mini_larg.set(mini.getAttribute("Larg"))
            self.mini_haut.set(mini.getAttribute("Haut"))
            self.mini_nb.set(mini.getAttribute("Nb"))

            misc=Node.getElementsByTagName("Divers")[0]
            self.police.set(misc.getAttribute("Police"))
            self.police_taille.set(misc.getAttribute("Taille"))
             


    def Menu(self):
        """
        Affiche le menu de la page de configuration
        """
        self.menu=Frame(self.top)
        self.menu.pack(side='top',fill='x',expand='no')
        b = Button(self.menu,relief="flat", text='Fermer',compound='left',
			image=self.gui.pixmap['fermer'],
			command=self.Fermer,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)
	b = Button(self.menu,relief="flat", text='Default',compound='left',
			image=self.gui.pixmap['vider'],
			command=self.Default,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)	
	b = Button(self.menu,relief="flat", text='Sauver',compound='left',
			image=self.gui.pixmap['sauver'],
			command=self.Sauver,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)

    def Default(self):
        self.user.set('grubs')
        self.host.set('localhost')
        self.pwd.set('grubs')
        self.db.set('grubs')
        self.photo_copier.set(True)
        self.compentry.component("entry").configure(state=NORMAL)
        self.repentry.component("entry").configure(state=NORMAL)        
        self.photo_rep.set('Photos')
        self.photo_larg.set('600')
        self.photo_haut.set('540')
        self.photo_comp.set('80')
        self.mini_larg.set('110')
        self.mini_haut.set('75')
        self.mini_nb=('5')
        self.police.set('Helvetica')
        self.police_taille.set('13')

    def Afficher(self):
        """
        Affiche l'interface de modification du fichier configuration
        """
        self.Menu()
        self.frame=Pmw.ScrolledFrame(self.top)
        self.frame.pack(side='top',expand='yes',fill='both')
        labelwidth=25
        entrywidth=20
        g=Pmw.Group(self.frame.interior(),tag_text='Base de donne',
                    tag_font=self.police_i)
        g.pack(side="top",padx = 5, pady = 5, expand='yes',
               anchor='nw',fill="none")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Nom d\'utilisateur',
                         entry_textvariable=self.user,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Nom de la machine',
                         entry_textvariable=self.host,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Mot de passe',
                         entry_textvariable=self.pwd,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Nom de la base de donne',
                         entry_textvariable=self.db,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        g=Pmw.Group(self.frame.interior(),tag_text='Photos',
                         tag_font=self.police_i)
        g.pack(side="top",padx = 5, pady = 5, expand='yes',
               anchor='nw',fill="none")
        e=Checkbutton(g.interior(),anchor='n',
                      onvalue=True, offvalue=False,
                      variable=self.photo_copier,command=self.copielocale,
                      text='Faire une copie locale des photos',)
        e.pack(side="top",fill="x",expand="yes")
        self.repentry=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Repertoire de copie',
                         entry_textvariable=self.photo_rep,
                         label_width=labelwidth)
        self.repentry._entryFieldEntry.grid( sticky = 'e' )
        self.repentry._entryFieldEntry.config( width = entrywidth )
        self.repentry.pack(side="top",fill="x",expand="yes")
        if not self.photo_copier.get():
            self.repentry.component("entry").configure(state=DISABLED)
        self.compentry=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Compression (1->100)',
                         entry_textvariable=self.photo_comp,
                         label_width=labelwidth)
        self.compentry._entryFieldEntry.grid( sticky = 'e' )
        self.compentry._entryFieldEntry.config( width = entrywidth )
        self.compentry.pack(side="top",fill="x",expand="yes")
        if not self.photo_copier.get():
            self.compentry.component("entry").configure(state=DISABLED)
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Largeur maximum (px)',
                         entry_textvariable=self.photo_larg,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Hauteur maximum (px)',
                         entry_textvariable=self.photo_haut,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        g=Pmw.Group(self.frame.interior(),tag_text='Vignettes',
                    tag_font=self.police_i)
        g.pack(side="top",padx = 5, pady = 5, expand='yes',
               anchor='w',fill='none')
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Largeur maximum (px)',
                         entry_textvariable=self.mini_larg,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Hauteur maximum (px)',
                         entry_textvariable=self.mini_haut,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Nombre par ligne',
                         entry_textvariable=self.mini_nb,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        
        g=Pmw.Group(self.frame.interior(),tag_text='Affichage',
                    tag_font=self.police_i)
        g.pack(side="top",padx = 5, pady = 5, expand='yes',
               anchor='w',fill='none')
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Police de charactre',
                         entry_textvariable=self.police,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")
        e=Pmw.EntryField(g.interior(),labelpos='w',
                         label_text='Taille de charactre',
                         entry_textvariable=self.police_taille,
                         label_width=labelwidth)
        e._entryFieldEntry.grid( sticky = 'e' )
        e._entryFieldEntry.config( width = entrywidth )
        e.pack(side="top",fill="x",expand="yes")        
        

    def copielocale(self):
        if self.photo_copier.get():
            self.compentry.component("entry").configure(state=NORMAL)
            self.repentry.component("entry").configure(state=NORMAL)
        else:
            self.compentry.component("entry").configure(state=DISABLED)
            self.repentry.component("entry").configure(state=DISABLED)

    def Fermer(self):
        """
        Ferme l'onglet de configuration
        """
        if self.Verifier():
            self.gui.Fermer()

    def Sauver(self):
        """
        Ecrit le fichier configuration config.xml
        Et cr une sauvegarde de l'ancien: config.xml.bak
        """
        if self.Verifier():
            dom = getDOMImplementation()
            doc = dom.createDocument(None, "GrubsConfig", None)
            Node = doc.documentElement
            
            database= doc.createElement("Database")
            Node.appendChild(database)
            database.setAttribute("User",str(self.user.get()))
            database.setAttribute("Pwd",str(self.pwd.get()))
            database.setAttribute("Host",str(self.host.get()))
            database.setAttribute("db",str(self.db.get()))

            photo= doc.createElement("Photo")
            Node.appendChild(photo)
            photo.setAttribute("Copier",str(self.photo_copier.get()))
            photo.setAttribute("Rep",str(self.photo_rep.get()))
            photo.setAttribute("Larg",str(self.photo_larg.get()))
            photo.setAttribute("Haut",str(self.photo_haut.get()))
            photo.setAttribute("Comp",str(self.photo_comp.get()))

            mini= doc.createElement("Mini")
            Node.appendChild(mini)
            mini.setAttribute("Larg",str(self.mini_larg.get()))
            mini.setAttribute("Haut",str(self.mini_haut.get()))
            mini.setAttribute("Nb",str(self.mini_nb.get()))
                          
            misc= doc.createElement("Divers")
            Node.appendChild(misc)
            misc.setAttribute("Police",str(self.police.get()))
            misc.setAttribute("Taille",str(self.police_taille.get()))

            import shutil
            shutil.copyfile(self.file, "%s.bak" % self.file)
            fid=open(self.file,"w")
            PrettyPrint(doc, fid)
            fid.close()      

            dialog.Info(self.top, msg="La nouvelle configuration a t sauvegarde\n"+
                       "Redmarez l'application pour prendre en compte les modifications\n"+
                       "(L'ancien fichier a t copi dans: %s.bak" % self.file).show()
            self.Fermer()

    def Verifier(self):
        """
        Vrifie que l'ensemble des champs du fichier de configuration
        sont renseigns et cohrents
        retourne un Boolean, True si la vrification et correcte
        """
        if self.user.get()=='':
            dialog.Errormsg(self.top, msg="Le champ User doit etre renseign !").show()
            return False
        elif self.host.get()=='':
            dialog.Errormsg(self.top, msg="Le champ Host doit etre renseign !").show()
            return False
        elif self.db.get()=='':
            dialog.Errormsg(self.top, msg="Le champ base de donne doit etre renseign !").show()
            return False
        elif self.photo_copier.get():
            if not os.path.isdir(str(self.photo_rep.get())):
                dialog.Errormsg(self.top, msg="Le repertoire de copie indiqu est introuvable !").show()
                return False
            elif self.photo_comp.get()=='':
                dialog.Errormsg(self.top, msg="Vous devez spcifier un taux de compression pour les photo copies").show()
                return False
        elif self.photo_larg.get()=='' or self.photo_haut.get()=='':
            dialog.Errormsg(self.top, msg="Vous devez spcifier une taille d'affichage pour les photos").show()
            return False
        elif self.mini_larg.get()=='' or self.mini_haut.get()=='':
            dialog.Errormsg(self.top, msg="Vous devez spcifier une taille d'affichage pour les miniatures").show()
            return False
        elif self.mini_nb.get()=='':
            dialog.Errormsg(self.top, msg="Vous devez spcifier un nombre de miniatures").show()
            return False
        elif self.police.get()=='':
            dialog.Errormsg(self.top, msg="Vous devez spcifier un nom de police de charactres").show()
            return False        
        elif self.police_taille.get()=='':
            dialog.Errormsg(self.top, msg="Vous devez spcifier une taille de police de charactres").show()
            return False
        else:
            import tkFont
            if self.police.get() not in tkfont.families():
                dialog.Errormsg(self.top, msg="La police de charactres choisie n'existe pas\ une police pas dfault sera charge").show()
                self.police.set('Courrier')  
        return True

    def printme(self):
        """
        Affichage sur la sortie python ligne de comande de la classe
        Utilis pour le debugage
        """
        print "fichier configuration : "+str(self.file)
        print "Database"
        print "  User : "+str(self.user.get())
        print "  Pwd  : "+str(self.pwd.get())
        print "  Host : "+str(self.host.get())
        print "  db   : "+str(self.db.get())
        print "Photo"
        print "  Larg        : "+str(self.photo_larg.get())
        print "  Haut        : "+str(self.photo_haut.get())
        print "  Compression : "+str(self.photo_comp.get())
        print "  Repertoire  : "+str(self.photo_rep.get())
        print "Mini"
        print "  Larg   : "+str(self.mini_larg.get())
        print "  Haut   : "+str(self.mini_haut.get())
        print "Police"
        print "  Police   : "+str(self.police.get())
        print "  Taille   : "+str(self.police_taille.get())
        
#==============================================
# Unitary testing 
#----------------------------------------------
if __name__=="__main__":
    top=Tk()
    print "Unitary testing of config module"
    config= Config('config.xml',top)
    config.printme()
    print "Writing variable..."
    config.Sauver()
    top.destroy()

        
