# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    Classe dfinissant les fenetres de dialog avec l'utilisateur
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

from Tkinter import *
import Pmw

class Dialog:
    """
    Classe dfinissant les fenetres de dialog avec l'utilisateur
    """
    def __init__(self, top,title,msg,button,default,icone,input='no'):
        if input=='no':
            self.dialog=Pmw.MessageDialog(top,title = title,message_text = msg,
                        buttonboxpos = 's',iconpos = 'n',icon_bitmap = icone,
                        buttons = button, defaultbutton = default,)
        elif input=='yes':
            self.dialog=Pmw.PromptDialog(top,title=title,label_text=msg,buttons = button,
                                         entryfield_labelpos='n',defaultbutton=default,)
        else:
            self.dialog=Pmw.Dialog(top,title=title,buttons=button,
                                   defaultbutton=default)
        self.dialog.withdraw()

    def execute(self,result):
        self.dialog.deactivate(result)
        
    def show(self):
        self.dialog.activate()   

class Errormsg(Dialog):
    """
    Fenetre destine aux messages d'erreur
    """
    def __init__(self, top,msg):
        button=('Ok',)
        default='Ok'
        icone='error'
        title='-=o0[ ERREUR ]0o=-'
        Dialog.__init__(self,top,title,msg,button,default,icone)

class Info(Dialog):
    """
    Fenetre destine aux messages a caractres informatifs
    """
    def __init__(self, top,msg):
        button=('Ok',)
        default='Ok'
        icone='info'
        title='-=o0[ Information o0]=-'
        Dialog.__init__(self,top,title,msg,button,default,icone)
        
class Question(Dialog):
    """
    Fentre posant une question a l'utilisateur, celui-ci repond par Ok
    ou Annuler
    """
    def __init__(self, top,msg):
        button=('Oui','Non')
        default='Oui'
        icone='question'
        title='-=o0[ Confirmation ]0o=-'
        Dialog.__init__(self,top,title,msg,button,default,icone)
        self.dialog.configure(command=self.execute)

    def execute(self,result):
        if result=='Oui':
            self.result=True
        else:
            self.result=False
        self.dialog.deactivate(result)

class Input(Dialog):
    """
    Fenetre demendant une valeur  l'utilisateur
    """
    def __init__(self, top,msg):
        button=('Ok','Annuler')
        default='Ok'
        icone='question'
        title='-=o0[ Question ]0o=-'
        Dialog.__init__(self,top,title,msg,button,default,icone,input='yes')
        self.dialog.configure(command=self.execute)

    def execute(self,result):
        if result is None or result != 'Ok':
             self.result=0
             self.dialog.deactivate(result)
        else:
             self.result=1
             self.input=self.dialog.get()
             self.dialog.deactivate()

class Liste(Dialog):
    """
    Fenetre proposant un choix multiple a l'utilisateur
    """
    def __init__(self,top,msg,liste):
        button=liste
        default=liste[0]
        icone='question'
        title='-=o0[ Question ]0o=-'
        Dialog.__init__(self,top,title,msg,button,default,icone,input='no')
        self.dialog.configure(command=self.execute)

    def execute(self,result):
        self.result=result
        self.dialog.deactivate()




    
