# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
                                   G.R.U.B.S
           Gestionnaire de Ressources a l'Usage du Biologiste Sous-marin

    N d'une premire version qui tait une site internet php/mysql, GRUBS est une
    interface python pour base de donne MySQL destin a faciliter la gestion de documents
    a l'usage des AFBS / IFBS et tout autre plongeur intress pas la bio.
    Il comprend un interface de remplissage de la base de donne ainsi qu'un formulaire de
    recherche.
    il comprend une partie ddi aux fiches d'identification des espces, une autres aux
    photos et une denire  tous type de documents (ecrit, audio ou video)
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

import Tkinter,Pmw,MySQLdb,os,sys
import config,gui,mysql,bio,splash,dialog

def MenuBar(top,gui):
    	balloon = Pmw.Balloon(top)
    	
	menuBar = Pmw.MenuBar(top,hull_relief = 'raised',hull_borderwidth = 1,padx=8,
			      balloon = balloon)
	menuBar.pack(fill = 'x')

	menuBar.addmenu('Home', 'Home',image=gui.pixmap['home'])
	menuBar.addcascademenu('Home','Configurer',traverseSpec = 'z', tearoff = 0,image=gui.pixmap['conf'],
			                compound='left')
	menuBar.addmenuitem('Configurer', 'command', 'Gnral',
					command = gui.Configurer,
					label = 'Gnral')
	menuBar.addmenuitem('Home', 'command', 'A propos',
					command = apropos,
					label = 'A propos')
	menuBar.addmenuitem('Home', 'command', 'Quitter',
					command = gui.Quitter,
					label = 'Quitter',image=gui.pixmap['quit'],
			                compound='left')
					
	menuBar.addmenu('Biologie', 'Biologie',image=gui.pixmap['bio'])
	menuBar.addmenuitem('Biologie', 'command', 'Editer la classification',
                                        command = gui.ClassifBio,
					label = 'Classification',image=gui.pixmap['arbre'],
			                compound='left')
	menuBar.addmenuitem('Biologie', 'command', 'Ajouter une fiche bio',
                                        command = gui.AjouterBio,
					label = 'Ajouter',image=gui.pixmap['add'],
			                compound='left')
	menuBar.addmenuitem('Biologie', 'command', 'Rechercher une fiche bio',
                                        command = gui.RechercherBio,
					label = 'Rechercher',image=gui.pixmap['search'],
			                compound='left')
               
                    
	menuBar.addmenu('Photo', 'Photo',image=gui.pixmap['photo'])
	menuBar.addmenuitem('Photo', 'command', 'Editer la localisation',
					command = gui.GeoPhoto,
					label = 'Localisation',image=gui.pixmap['arbre'],
			                compound='left')
	menuBar.addmenuitem('Photo', 'command', 'Ajouter une photo',
					command = gui.AjouterPhoto,
					label = 'Ajouter',image=gui.pixmap['add'],
			                compound='left')
	menuBar.addmenuitem('Photo', 'command', 'Rechercher une photo',
					command = gui.RechercherPhoto,
					label = 'Rechercher',image=gui.pixmap['search'],
			                compound='left')
  
	
	menuBar.addmenu('Documents', 'Documents',image=gui.pixmap['doc'])
	menuBar.addmenuitem('Documents', 'command', 'Ajouter un document',
					command = gui.AjouterMedia,
					label = 'Ajouter',image=gui.pixmap['add'],
			                compound='left')
	menuBar.addmenuitem('Documents', 'command', 'Rechercher un document',
					command = gui.RechercherMedia,
					label = 'Rechercher',image=gui.pixmap['search'],
			                compound='left')

##	menuBar.addmenu('MySQL', 'MySQL',image=gui.pixmap['mysql'])
##	menuBar.addmenuitem('MySQL', 'command', 'Mettre  jour',
##					command = gui.MajMysql,
##					label = 'Mettre  jour',image=gui.pixmap['maj'],
##			                compound='left')
##	menuBar.addmenuitem('MySQL', 'command', 'Sauvegarder',
##					command = gui.SaveMysql,
##					label = 'Sauvegarder',image=gui.pixmap['backup'],
##			                compound='left')                    
##	menuBar.addmenuitem('MySQL', 'command', 'Requte',
##                                        command = gui.RequeteMysql,
##					label = 'Requte',image=gui.pixmap['requete'],
##			                compound='left')

def Test_Env():
    """
    test si les fichier de configuration sont bien prsents
    """
    if not os.path.isfile("./config.xml"):
	    msg="Le fichier de configuration (config.xml) est manquant !\nImpossible de dmarrer l'application"
	    dialog.Errormsg(root,msg).show()
	    return False
    if not os.path.isfile("./classif.xml"):
	    msg="Le fichier de classification (classif.xml) est manquant !\nImpossible de dmarrer l'application"
	    dialog.Errormsg(root,msg).show()
	    return False
    if not os.path.isfile("./geographie.xml"):
	    msg="Le fichier de localisation (localisation.xml) est manquant !\nImpossible de dmarrer l'application"
	    dialog.Errormsg(root,msg).show()
	    return False
    return True
    

def Test_db(conf,splash):
    try:
	    conn=MySQLdb.connect(host=conf.host.get())
	    conn.close()
	    try:
                conn=MySQLdb.connect(host=conf.host.get(),user=conf.user.get(),passwd=conf.pwd.get())
                conn.close()
                mysql_test=mysql.Mysql(conf)
                if not mysql_test.DbIsOn():
                        splash.destroy()
                        msg="Impossible de trouver la Base de donne "+str(conf.db.get())+" !\n"
                        msg+="Veuillez vrifier la configuration de l'application !"
                        q=dialog.Errormsg(root,msg).show()
                        return False
                if not mysql_test.DbHaveTable():
                        splash.destroy()
                        msg="La base donne "+str(conf.db.get())+" n'est pas initialise correctement !\n"
                        msg+="Repassez par l'tape d'initialisation de MySQL (voire README.txt)"
                        q=dialog.Errormsg(root,msg).show()
                        return False
                                
	    except:
                   splash.destroy()
		   msg="Nom d'utilisateur ou mot de passe incorrect pour MySQL !\n"
		   msg+="Veuillez vrifier la configuration de l'application !"
		   dialog.Errormsg(root,msg).show()
                   return False
    except:
            splash.destroy()
	    msg="Impossible de se connecter a MySQL !\n"
	    msg+="Verifiez que votre serveur MySQL est lanc et que le nom d'hote est correcte dans le fichier de configuration de G.R.U.B.S."
	    dialog.Errormsg(root,msg).show()
	    return False
    return True

def apropos():
	splashscreen=splash.SplashScreen(root,600,400,timeout=None, image="./grubs.gif")
	splashscreen.msg.set("Gestionaire de Ressousrces  l'Usage du Biologiste Sous-marin - GRUBS v1.0")


#========================================================================================= 
# Main
#-----------------------------------------------------------------------------------------
if __name__ == '__main__':

        import time
       	global root
	root=Tkinter.Tk()
	splashscreen=splash.SplashScreen(root,600,400,timeout=None, image="./grubs.gif")
	splashscreen.msg.set('Verification des fichiers...')
	splashscreen.update()
	if not Test_Env():
            splashscreen.destroy()
            sys.exit()
	time.sleep(0.5)	
	splashscreen.msg.set("Chargement des paramtres...")
        splashscreen.update()
        root.option_readfile('./layout.ini')
        conf=config.Config("./config.xml",root,None)
        time.sleep(0.5)
	splashscreen.msg.set('Verification de la base de donne...')
	Test_db(conf,splashscreen)
	try:
            splashscreen.update()
            time.sleep(0.5)
        except:
            pass
	root.option_add("*Font", conf.police_n)

        try:
            splashscreen.msg.set("Lancement de l'application...")
            time.sleep(0.5)
            splashscreen.destroy()
        except:
            pass
        
        xmax = root.winfo_screenwidth()
        ymax = root.winfo_screenheight()
       	root.wm_geometry(str(xmax-50)+'x'+str(ymax-100)+'+0+0')
	Pmw.initialise(root)
	root.wm_title("G.R.U.B.S. - Gestionaire de Ressources a l'Usage du Biologiste Sous-marin")
	gui= gui.Gui(root,conf)
	conf.gui=gui
	conf.Verifier()
	MenuBar(root,gui)
	root.mainloop()
