# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    Classe dfinissant l'agencement graphique, multi-fentre de l'application
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

import Pmw,sys,os,copy
import tkFileDialog
from Tkinter import *
from PIL import Image,ImageTk
import bio,photo,config,mysql,media

class Gui:
    """
    Classe dfinissant l'agencement graphique, multi-fentre de l'application
    """    
    def __init__(self,top,conf):
        """
        Initialise l'ensemble des fentres
        et cr le dictionnaire des icones
        """
        self.top=top
        self.config=conf
        self.pixmap={}
        self.pixmap['home']=PhotoImage(file="./pixmap/home.gif")
        self.pixmap['bio']=PhotoImage(file="./pixmap/bio.gif")
        self.pixmap['photo']=PhotoImage(file="./pixmap/photo.gif")
        self.pixmap['doc']=PhotoImage(file="./pixmap/doc.gif")
        self.pixmap['mysql']=PhotoImage(file="./pixmap/mysql.gif")
        self.pixmap['add']=PhotoImage(file="./pixmap/ajouter.gif")
        self.pixmap['search']=PhotoImage(file="./pixmap/rechercher.gif")
        self.pixmap['requete']=PhotoImage(file="./pixmap/question.gif")
        self.pixmap['maj']=PhotoImage(file="./pixmap/maj.gif")
        self.pixmap['arbre']=PhotoImage(file="./pixmap/arbre.gif")
        self.pixmap['conf']=PhotoImage(file="./pixmap/configurer.gif")
        self.pixmap['quit']=PhotoImage(file="./pixmap/quitter.gif")
        self.pixmap['backup']=PhotoImage(file="./pixmap/backup.gif")
        self.pixmap['sauver']=PhotoImage(file="./pixmap/sauver.gif")
        self.pixmap['supprimer']=PhotoImage(file="./pixmap/supprimer.gif")
        self.pixmap['fermer']=PhotoImage(file="./pixmap/fermer.gif")
        self.pixmap['vider']=PhotoImage(file="./pixmap/vider.gif")
        self.pixmap['editer']=PhotoImage(file="./pixmap/vider.gif")
        self.pixmap['niv1']=PhotoImage(file="./pixmap/niveau1.gif")
        self.pixmap['niv2']=PhotoImage(file="./pixmap/niveau2.gif")
        self.pixmap['niv3']=PhotoImage(file="./pixmap/niveau3.gif")
        self.pixmap['niv3v']=PhotoImage(file="./pixmap/niveau3v.gif")
        self.pixmap['nivvide']=PhotoImage(file="./pixmap/niveauvide.gif")
        
        # ligne pour le menu global
        self.menu= Frame(self.top,relief="raised")
	self.menu.pack(side="bottom",fill="none",expand="no")
	# fenetre principale
	self.principal=Pmw.PanedWidget(self.top, hull_width=0,hull_height=0)
        self.principal.pack(side="bottom",fill="both",expand="yes",)
        self.principal.add('main',min=0)
        self.fenetre=Pmw.NoteBook(self.principal.pane("main"))
        self.fenetre.pack(side="top",fill="both",expand="yes")
        

    def Quitter(self):
        """
        Ferme les fenetres de l'application
        """
        self.top.destroy()

    def Fermer(self):
        """
        Ferme l'onglet nomm titre
        """
        self.fenetre.delete(Pmw.SELECT)

    def AfficherBio(self,id):
        try:
            fen_bio = self.fenetre.add('**Bio**'+str(id)+"**")
            affiche=bio.Bio_Fiche_Afficher(fen_bio,self,id)
            self.fenetre.tab('**Bio**'+str(id)+'**').configure(text='Fiche Bio '+str(id))
            affiche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Bio**'+str(id)+'**')
        self.fenetre.tab('**Bio**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=affiche,titre='Fiche Bio '+str(id):\
                                self.PopupMenu(event,objet,titre))

    def ModifierBio(self,id):
        try:
            fen_bio = self.fenetre.add('**Bio**'+str(id)+"**")
        except ValueError:
            self.fenetre.delete('**Bio**'+str(id)+"**")
            fen_bio = self.fenetre.add('**Bio**'+str(id)+"**")
        modif=bio.Bio_Fiche_Modifier(fen_bio,self,id)
        self.fenetre.tab('**Bio**'+str(id)+'**').configure(text='Fiche Bio '+str(id))
        modif.Afficher()
        self.fenetre.selectpage('**Bio**'+str(id)+'**')           
        self.fenetre.tab('**Bio**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=modif,titre='Modifier Fiche Bio '+str(id):\
                                self.PopupMenu(event,objet,titre))
    def AjouterBio(self):
        try:
            fen_bio = self.fenetre.add('**Ajouter**Bio**')
            ajout=bio.Bio_Fiche_Ajouter(fen_bio,self)
            self.fenetre.tab('**Ajouter**Bio**').configure(text='Bio: Ajouter')
            ajout.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Ajouter**Bio**')
        self.fenetre.tab('**Ajouter**Bio**').bind('<ButtonPress-3>',
                         lambda event, objet=ajout,titre='Bio: Ajouter':\
                                self.PopupMenu(event,objet,titre))
                                                                            
    def RechercherBio(self):
        try:
            fen_bio = self.fenetre.add('**Rechercher**Bio**')
            recherche=bio.Bio_Fiche_Rechercher(fen_bio,self)
            self.fenetre.tab('**Rechercher**Bio**').configure(text='Bio: Rechercher')
            recherche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Rechercher**Bio**')
        self.fenetre.tab('**Rechercher**Bio**').bind('<ButtonPress-3>',
                         lambda event, objet=recherche,titre='Bio: Rechercher':\
                                self.PopupMenu(event,objet,titre))
    def ClassifBio(self):
        try:
            fen_bio = self.fenetre.add('**Classification**Bio**')
            classif=bio.Bio_classif(fen_bio,self)
            self.fenetre.tab('**Classification**Bio**').configure(text='Bio: Classification')
            classif.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Classification**Bio**') 
        self.fenetre.tab('**Classification**Bio**').bind('<ButtonPress-3>',
                         lambda event, objet=classif,titre='Bio: Classification':\
                                self.PopupMenu(event,objet,titre))
        
    def RequeteMysql(self):
        try:
            fen_mysql = self.fenetre.add('**MySQL**')
            onglet_mysql=mysql.Mysql(self.config,fen_mysql)
            self.fenetre.tab('**MySQL**').configure(text='MYSQL')
            onglet_mysql.Afficher(self)
        except:
            pass
        self.fenetre.selectpage('**MySQL**')
        self.fenetre.tab('**MySQL**').bind('<ButtonPress-3>',
                     lambda event, objet=onglet_mysql,titre='MySQL':\
                            self.PopupMenu(event,objet,titre))
    
    def GeoPhoto(self):
        try:
            fen_photo = self.fenetre.add('**Localisation**Photo**')
            geo=photo.Photo_geo(fen_photo,self)
            self.fenetre.tab('**Localisation**Photo**').configure(text='Photo: Localisation')
            geo.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Localisation**Photo**') 
        self.fenetre.tab('**Localisation**Photo**').bind('<ButtonPress-3>',
                         lambda event, objet=geo,titre='Photo: Localisation':\
                                self.PopupMenu(event,objet,titre))
        
    def AfficherPhoto(self,id):
        try:
            fen_photo = self.fenetre.add('**Photo**'+str(id)+"**")
            affiche=photo.Photo_Fiche_Afficher(fen_photo,self,id)
            self.fenetre.tab('**Photo**'+str(id)+'**').configure(text='Fiche Photo '+str(id))
            affiche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Photo**'+str(id)+'**')
        self.fenetre.tab('**Photo**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=affiche,titre='Fiche Photo '+str(id):\
                                self.PopupMenu(event,objet,titre))

    def ModifierPhoto(self,id):
        try:
            fen_photo = self.fenetre.add('**Photo**'+str(id)+"**")
        except ValueError:
            self.fenetre.delete('**Photo**'+str(id)+"**")
            fen_photo = self.fenetre.add('**Photo**'+str(id)+"**")
        modif=photo.Photo_Fiche_Modifier(fen_photo,self,id)
        self.fenetre.tab('**Photo**'+str(id)+'**').configure(text='Photo '+str(id))
        modif.Afficher()
        self.fenetre.selectpage('**Photo**'+str(id)+'**')           
        self.fenetre.tab('**Photo**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=modif,titre='Modifier Photo '+str(id):\
                                self.PopupMenu(event,objet,titre))

    def AjouterPhoto(self):
        try:
            fen_photo = self.fenetre.add('**Ajouter**Photo**')
            ajout=photo.Photo_Fiche_Ajouter(fen_photo,self)
            self.fenetre.tab('**Ajouter**Photo**').configure(text='Photo: Ajouter')
            ajout.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Ajouter**Photo**')
        self.fenetre.tab('**Ajouter**Photo**').bind('<ButtonPress-3>',
                         lambda event, objet=ajout,titre='Photo: Ajouter':\
                                self.PopupMenu(event,objet,titre))

    def RechercherPhoto(self):
        try:
            fen_photo = self.fenetre.add('**Rechercher**Photo**')
            recherche=photo.Photo_Fiche_Rechercher(fen_photo,self)
            self.fenetre.tab('**Rechercher**Photo**').configure(text='Photo: Rechercher')
            recherche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Rechercher**Photo**')
        self.fenetre.tab('**Rechercher**Photo**').bind('<ButtonPress-3>',
                         lambda event, objet=recherche,titre='Photo: Rechercher':\
                                self.PopupMenu(event,objet,titre))

    def AjouterMedia(self):
        try:
            fen_media = self.fenetre.add('**Ajouter**Media**')
            ajout=media.Media_Ajouter(fen_media,self)
            self.fenetre.tab('**Ajouter**Media**').configure(text='Media: Ajouter')
            ajout.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Ajouter**Media**')
        self.fenetre.tab('**Ajouter**Media**').bind('<ButtonPress-3>',
                         lambda event, objet=ajout,titre='Media: Ajouter':\
                                self.PopupMenu(event,objet,titre))

    def RechercherMedia(self):
        try:
            fen_media = self.fenetre.add('**Rechercher**Media**')
            recherche=media.Media_Rechercher(fen_media,self)
            self.fenetre.tab('**Rechercher**Media**').configure(text='Media: Rechercher')
            recherche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Rechercher**Media**')
        self.fenetre.tab('**Rechercher**Media**').bind('<ButtonPress-3>',
                         lambda event, objet=recherche,titre='Media: Rechercher':\
                                self.PopupMenu(event,objet,titre))

    def AfficherMedia(self,id):
        try:
            fen_media = self.fenetre.add('**Media**'+str(id)+"**")
            affiche=media.Media_Afficher(fen_media,self,id)
            self.fenetre.tab('**Media**'+str(id)+'**').configure(text='Document '+str(id))
            affiche.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Media**'+str(id)+'**')
        self.fenetre.tab('**Media**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=affiche,titre='Document '+str(id):\
                                self.PopupMenu(event,objet,titre))

    def ModifierMedia(self,id):
        try:
            fen_media = self.fenetre.add('**Media**'+str(id)+"**")
        except ValueError:
            self.fenetre.delete('**Media**'+str(id)+"**")
            fen_media = self.fenetre.add('**Media**'+str(id)+"**")
        modif=media.Media_Modifier(fen_media,self,id)
        self.fenetre.tab('**Media**'+str(id)+'**').configure(text='Document '+str(id))
        modif.Afficher()
        self.fenetre.selectpage('**Media**'+str(id)+'**')           
        self.fenetre.tab('**Media**'+str(id)+'**').bind('<ButtonPress-3>',
                         lambda event, objet=modif,titre='Modifier Document '+str(id):\
                                self.PopupMenu(event,objet,titre))        

    def MajMysql(self):
        file=tkFileDialog.askopenfilename(title="Fichier MySQL",
                                          filetypes=[("MySQL file",".sql")])
        if file==():
            pass
        else:
            db=mysql.Mysql(self.config,self.top)
            db.LoadFile(file)
 
    def SaveMysql(self):
        file=tkFileDialog.asksaveasfilename(title="Fichier MySQL",
                                            filetypes=[("MySQL file",".sql")])
        if file==():
            pass
        else:
            db=mysql.Mysql(self.config,self.top)
            db.SaveFile(file)

    def Configurer(self):
        try:
            fen_config = self.fenetre.add('**Configuration**')
            conf=config.Config("./config.xml",fen_config,self)
            self.fenetre.tab('**Configuration**').configure(text='Configuration')
            conf.Afficher()
        except:
            pass
        self.fenetre.selectpage('**Configuration**')     

    def PopupMenu(self,e,objet,titre):
        self.popup=Menu(self.top,tearoff=0)
        self.popup.add_command(label="Ouvrir dans une nouvelle fenetre",
                               command=lambda objet=objet, titre=titre:self.NouvelleFenetre(objet,titre))
        self.popup.post(e.x_root-5,e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    def FermerPopup(self,*e):
        """
        Ferme le popup menu du click droit
        """        
        self.popup.destroy()        

    def NouvelleFenetre(self,objet,titre):
        objet.top=Toplevel(self.top)
        objet.top.wm_title("G.R.U.B.S - "+titre)
        xmax = self.top.winfo_screenwidth()
        ymax = self.top.winfo_screenheight()
       	objet.top.wm_geometry(str(xmax-50)+'x'+str(ymax-100)+'+10+10')
        objet.Fermer()
        objet.fullwindow=True
        objet.Afficher()

