# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    Classe grant les medias (documents autres que des photos)
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

from Tkinter import *
import tkFileDialog
import Pmw,os,re
import mysql,tools,dialog,progress

class Media:
    """
    Classe grant les fiches medias
    Classe drives: Media_fiche
    """
    def __init__(self,top,gui,id=None):
        self.top=top
        self.gui=gui
        self.fullwindow=False           # fenetre pleine cran ou onlget
        self.db=mysql.Mysql(gui.config,self.top)
        self.id=id
        self.type=StringVar()
        self.titre=StringVar()
        self.auteur=StringVar()
        self.format=StringVar()
        self.fichier=StringVar()
        self.backup=StringVar()
        self.comment=None
        self.langue=StringVar()
        self.chemin=StringVar()
        self.pixmap={}
        self.pixmap['video']=PhotoImage(file="./pixmap/video.gif")
        self.pixmap['audio']=PhotoImage(file="./pixmap/audio.gif")
        self.pixmap['schema']=PhotoImage(file="./pixmap/schema.gif")
        self.pixmap['text']=PhotoImage(file="./pixmap/text.gif")
        self.pixmap['fr']=PhotoImage(file="./pixmap/fr.gif")
        self.pixmap['esp']=PhotoImage(file="./pixmap/esp.gif")
        self.pixmap['en']=PhotoImage(file="./pixmap/en.gif")
        self.pixmap['all']=PhotoImage(file="./pixmap/all.gif")

    def Fermer(self):
        """
        Ferme l'onglet
        """
        if self.fullwindow:
            self.top.destroy()
        else:
            self.gui.Fermer()

    def FermerPopup(self,*e):
        """
        Ferme le popup menu du click droit
        """        
        self.popup.destroy()

    def LireFiche(self):
        """
        Charge la fiche du media de la base de donne
        """        
        champs=['type','titre','auteur','format','fichier','sauvegarde',\
                'comment','langue','chemin']
        condition="ID='"+str(self.id)+"'"
        res=self.db.select('media',champs,condition)
        self.type.set(res[0][0])
        self.titre.set(res[0][1])
        self.auteur.set(res[0][2])
        self.format.set(res[0][3])
        self.fichier.set(res[0][4])
        self.backup.set(res[0][5])
        self.comment=StringVar()
        self.comment.set(res[0][6])
        self.langue.set(res[0][7])
        self.chemin.set(res[0][8])

    def Menu(self,actions):
        self.menu=Frame(self.top)
        self.menu.pack(side='top',fill='x',expand='no')
        b = Button(self.menu,relief="flat", text='Fermer',compound='left',
			image=self.gui.pixmap['fermer'],
			command=self.Fermer,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)
        if 'vider' in actions:
            b = Button(self.menu,relief="flat", text='Vider',compound='left',
                    image=self.gui.pixmap['vider'],
                    command=self.Vider,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'sauver' in actions:
            b = Button(self.menu,relief="flat", text='Sauver',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Sauver,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'rechercher' in actions:
            b = Button(self.menu,relief="flat", text='Rechercher',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Rechercher,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'supprimer' in actions:
            b = Button(self.menu,relief="flat", text='Supprimer',compound='left',
                    image=self.gui.pixmap['supprimer'],
                    command=lambda id=self.id :self.SupprimerFiche(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'modifier' in actions:
            b = Button(self.menu,relief="flat", text='Editer',compound='left',
                    image=self.gui.pixmap['editer'],
                    command=lambda id=self.id :self.Modifier(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)

    def Sauver(self):
        pass

    def Vider(self):
        self.type.set('Rapport/Memo')
        self.titre.set('')
        self.auteur.set('')
        self.format.set('')
        self.fichier.set('')
        self.backup.set('')
        self.langue.set('fr')

    def Modifier(self,id):
        self.gui.ModifierMedia(id)

    def Afficher(self,id):
        self.gui.AfficherMedia(id)

    def FormComment(self,top):        
        self.formcomment=Pmw.Group(top,tag_text='Rsum',
                                   tag_font=self.gui.config.police_i)
        self.formcomment.pack(side="top",padx = 5, pady = 5,expand='no',
                              anchor='w',fill="x")

    def AfficherFiche(self,id):
        self.gui.AfficherMedia(id)

    def ModifierFiche(self,id):
        self.gui.ModifierMedia(id)

    def SupprimerFiche(self,id):
        q=dialog.Question(self.top,"\nSupprimer la Fiche Media "+str(id)+" ? \n")
        q.show()
        if bool(q.result):
            res=self.db.SupprimerMedia(id)
            if res!='error':
                dialog.Info(self.top,"La fiche Photo "+str(id)+" a t supprime\n").show()
        else:
            pass
        return q.result        
        
class Media_Ajouter(Media):     
    """
    Classe d'ajout des fiches Media
    """
    def __init__(self,top,gui,id=None):
        Media.__init__(self,top,gui,id)
        self.formlangue=None
        self.formtype=None

    def Vider(self):
        Media.Vider(self)
        if self.formlangue is not None:
            self.formlangue.invoke(self.langue.get())
        if self.formtype is not None:
            self.formtype.invoke(self.type.get())
        if self.comment is not None:
            self.comment.settext('')
        
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='w',
                    fill='x', padx = 0, pady = 0)

    def Afficher(self):
        self.Menu(['sauver','vider'])
        self.MiseEnPage()
        self.FormGeneral(self.h)
        self.FormComment(self.h)

    def FormGeneral(self,top):
        self.formgeneral=Pmw.Group(top,tag_text='Gnralits',
                                   tag_font=self.gui.config.police_i)
        self.formgeneral.pack(side="top",padx = 5, pady = 5,expand='no',
                              anchor='n',fill="none")
        labelwidth=12
        entrywidth=62
        buttonheight=18
        # fichier
        f=Frame(self.formgeneral.interior())
        f.pack(side="top",expand="yes",fill="x",anchor='w',padx=0,pady=0)
        e=Pmw.EntryField(f,labelpos='w',label_text='Fichier : ',
                         entry_textvariable=self.fichier,
                         label_width=labelwidth,label_anchor='e')
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth-9)
        e.pack(side="left",fill="both",expand="yes",padx=3,pady=3,anchor='w')
        b=Button(f, text='...', command=self.OuvrirFichier,width=4)
        b.pack(side='left',fill='both',padx=2,pady=2)
        # titre
        e=Pmw.EntryField(self.formgeneral.interior(),labelpos='w',
                         label_text='Titre :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.titre)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="top",fill="none",expand="no",padx=3,pady=3,anchor='w')
        # auteur
        e=Pmw.EntryField(self.formgeneral.interior(),labelpos='w',
                         label_text='Auteur :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.auteur)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="top",fill="none",expand="no",padx=3,pady=3,anchor='w')
        # type
        self.formtype=Pmw.RadioSelect(self.formgeneral.interior(),
                            buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checktype,label_text = 'Type :',
                            label_width=labelwidth,label_anchor='e',padx=10)
        self.formtype.pack(side = 'top', expand = 'no', padx = 3, pady = 3, anchor='w',
               fill='none')
        self.formtype.add('Video',image=self.pixmap['video'],height=buttonheight)
        b=Pmw.Balloon(self.top)
        b.bind(self.formtype.component('Video'),'Video')
        self.formtype.add('Son',image=self.pixmap['audio'],height=buttonheight)
        b=Pmw.Balloon(self.top)
        b.bind(self.formtype.component('Son'),'Audio')
        self.formtype.add('Rapport/Memo',image=self.pixmap['text'],height=buttonheight)
        b=Pmw.Balloon(self.top)
        b.bind(self.formtype.component('Rapport/Memo'),'Text')
        self.formtype.add('Schema',image=self.pixmap['schema'],height=buttonheight)
        b=Pmw.Balloon(self.top)
        b.bind(self.formtype.component('Schema'),'Schema')
        if self.type.get()=='':
            self.type.set('Rapport/Memo')
        self.formtype.invoke(self.type.get())
        # langue
        self.formlangue = Pmw.RadioSelect(self.formgeneral.interior(),
                            buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checklangue,label_text = 'Langue :',
                            label_width=labelwidth,label_anchor='e',padx=10)
        self.formlangue.pack(side = 'top', expand = 'no', padx = 3, pady = 3, anchor='w',
               fill='none')
        self.formlangue.add('fr',image=self.pixmap['fr'],height=buttonheight)
        self.formlangue.add('en',image=self.pixmap['en'],height=buttonheight)
        self.formlangue.add('esp',image=self.pixmap['esp'],height=buttonheight)
        self.formlangue.add('all',image=self.pixmap['all'],height=buttonheight)
        self.formlangue.add('autre')
        if self.langue.get()=='':
            self.langue.set('fr')
        self.formlangue.invoke(self.langue.get())
        # sauvegarde
        e=Pmw.EntryField(self.formgeneral.interior(),labelpos='w',
                         label_text='Sauvegarde :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.backup)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth/3)
        e.pack(side="top",fill="none",expand="no",padx=3,pady=3,anchor='w')


    def FormComment(self,top):        
        Media.FormComment(self,top)
        if self.comment is not None:
            comment=self.comment.get()
        else:
            comment=''
        self.comment=Pmw.ScrolledText(self.formcomment.interior(),text_padx = 0,
                                      text_pady = 4,
                                      usehullsize = 1,
#                                      hull_width = 270,
                                      hull_height = 150,
                                      text_wrap='word')
        self.comment.pack(side="top",padx=0,pady=5,expand='no',fill='x')
        self.comment.settext(comment)      

    def OuvrirFichier(self):
        file=tkFileDialog.askopenfilename()
        if file==():
            pass
	else:
            self.fichier.set(file)

    def checklangue(self,tag):
        self.langue.set(str(tag))
        
    def checktype(self,tag):
        self.type.set(str(tag))

    def Sauver(self,Modifier=False):
        go_on=True
        if self.fichier.get() =='':
            e=dialog.Question(self.top,"Fichier vide !\Etes vous sur de vouloir inserer un mdia sans fichier ?")
            e.show()
            if e.result:
                self.fichier.set('None')
                go_on=True
            else:
                go_on=False
            
        else:
            exist,id=self.db.ElementExist('media',
                                          "titre=\""+tools.nettoyer(self.titre.get())+\
                                          "\" AND fichier=\""+\
                                          tools.nettoyer(self.fichier.get())+"\"")
            if exist and not Modifier:
                q=dialog.Question(self.top,"Ce document existe dja"+\
                                  "\nSouhaitez vous le remplacer ?")
                q.show()
                if q.result:
                    self.id=id
                    Modifier=True
                else:
                    go_on=False
        if self.fichier.get()!='None':
            self.format.set(re.split('\.',os.path.basename(self.fichier.get()))[1])
        else:
            self.format.set('None')
        if go_on:
            elements=[]
            elements.append('type="'+tools.nettoyer(self.type.get())+'"')
            elements.append('titre="'+tools.nettoyer(self.titre.get())+'"')
            elements.append('auteur="'+tools.nettoyer(self.auteur.get())+'"')
            elements.append('format="'+tools.nettoyer(self.format.get())+'"')
            elements.append('chemin="'+tools.nettoyer(self.fichier.get())+'"')
            elements.append('fichier="'+str(os.path.basename(tools.nettoyer(self.fichier.get())))+'"')
            elements.append('comment="'+self.comment.get()[:-1]+'"')
            elements.append('langue="'+tools.nettoyer(self.langue.get())+'"')
            elements.append('sauvegarde="'+tools.nettoyer(self.backup.get())+'"')
            if not Modifier:
                res,id=self.db.ajouter('media',elements)
            else:
                res=self.db.modifier('media',elements,str(self.id))
            if res!='error':
                i=dialog.Info(self.top,"Le document: "+str(self.titre.get().encode('latin-1'))+" a t ajoute")
                i.show()
        

class Media_Rechercher(Media):
    """
    Classe de recherche de medias
    """
    def __init__(self,top,gui):
        Media.__init__(self,top,gui,None)
        self.tri='titre'
        self.type.set('Tous')
        self.langue.set('Toutes')
        self.comment=StringVar()
        self.avancement=None

    def MiseEnPage(self):
        self.win=Pmw.PanedWidget(self.top,orient='vertical')
        self.win.pack(side="top",fill="both",expand="yes")
        self.win.add('recherche',min=0)
        self.win.add('resultat',min=0)
        self.h=Pmw.ScrolledFrame(self.win.pane("recherche"))
        self.h.pack(side="top",expand="yes",fill="none",anchor='n')
        self.h.component('frame').pack(expand='no')
        self.b=None

    def Vider(self):
        Media.Vider(self)
        self.comment.set('')
        self.langue.set('Toutes')
        self.type.set('Tous')
        if self.formlangue is not None:
            self.formlangue.invoke(self.langue.get())
        if self.formtype is not None:
            self.formtype.invoke(self.type.get())        
        try:
            self.b.destroy()
        except:
            pass

    def Afficher(self):
        self.Menu(['rechercher','vider'])
        self.MiseEnPage()
        self.FormRecherche(self.h.interior())

    def FormRecherche(self,top):
        self.formrecherche=Pmw.Group(top,tag_text='Recherche',
                                   tag_font=self.gui.config.police_i)
        self.formrecherche.pack(side="top",padx = 5, pady = 5,expand='no',
                              anchor='n',fill="none")
        labelwidth=12
        entrywidth=15
        buttonheight=18
        # type
        self.formtype=Pmw.RadioSelect(self.formrecherche.interior(),
                            buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checktype,label_text = 'Type :',
                            label_width=labelwidth,label_anchor='e',padx=10)
        self.formtype.pack(side = 'top', expand = 'no', padx = 3, pady = 3, anchor='w',
               fill='none')
        self.formtype.add('Video',image=self.pixmap['video'],height=buttonheight)
        self.formtype.add('Son',image=self.pixmap['audio'],height=buttonheight)
        self.formtype.add('Rapport/Memo',image=self.pixmap['text'],height=buttonheight)
        self.formtype.add('Schema',image=self.pixmap['schema'],height=buttonheight)
        self.formtype.add('Tous')
        self.formtype.invoke(self.type.get())
        # langue
        self.formlangue = Pmw.RadioSelect(self.formrecherche.interior(),
                            buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checklangue,label_text = 'Langue :',
                            label_width=labelwidth,label_anchor='e',padx=10)
        self.formlangue.pack(side = 'top', expand = 'no', padx = 3, pady = 3, anchor='w',
               fill='none')
        self.formlangue.add('fr',image=self.pixmap['fr'],height=buttonheight)
        self.formlangue.add('en',image=self.pixmap['en'],height=buttonheight)
        self.formlangue.add('esp',image=self.pixmap['esp'],height=buttonheight)
        self.formlangue.add('all',image=self.pixmap['all'],height=buttonheight)
        self.formlangue.add('autre')
        self.formlangue.add('Toutes')
        self.formlangue.invoke(self.langue.get())

        f=Frame(self.formrecherche.interior())
        f.pack(side="top",expand="yes",fill="x",anchor='w',padx=0,pady=0)
        # titre
        e=Pmw.EntryField(f,labelpos='w',
                         label_text='Titre :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.titre)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3,anchor='w')
        # auteur
        e=Pmw.EntryField(f,labelpos='w',
                         label_text='Auteur :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.auteur)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3,anchor='e')

        f=Frame(self.formrecherche.interior())
        f.pack(side="top",expand="yes",fill="x",anchor='w',padx=0,pady=0)        
        # resume
        e=Pmw.EntryField(f,labelpos='w',
                         label_text='Rsum :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.comment)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3,anchor='w')
        # sauvegarde
        e=Pmw.EntryField(f,labelpos='w',
                         label_text='Sauvegarde :',label_width=labelwidth,
                         label_anchor='e',
                         entry_textvariable=self.backup)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=entrywidth)
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3,anchor='e')

        f=Frame(self.formrecherche.interior())
        f.pack(side="top",expand="yes",fill="x",anchor='w',padx=0,pady=0)
        l=Label(f,text='(Wildcard %)',anchor='e')
        l.pack(side='top',expand='no',fill='none',anchor='e')

    def checklangue(self,tag):
        self.langue.set(str(tag))
        
    def checktype(self,tag):
        self.type.set(str(tag))

    def Rechercher(self):
        champs=['ID','titre','auteur','type','langue','sauvegarde','fichier',\
                'comment']
        condition='(1 '
        if self.type.get()!='Tous':
            condition+=" AND type ='"+str(self.type.get())+"'"
        if self.titre.get()!='':
            condition+=" AND titre LIKE '%"+tools.nettoyer(self.titre.get())+"%'"
        if self.backup.get()!='':
            condition+=" AND sauvegarde LIKE '%"+tools.nettoyer(self.backup.get())+"%'"
        if self.comment.get()!='':
            condition+=" AND comment LIKE '%"+tools.nettoyer(self.comment.get())+"%'"
        if self.auteur.get()!='':
            condition+=" AND auteur LIKE '%"+tools.nettoyer(self.auteur.get())+"%'"            
        if self.langue.get()!='Toutes':
            condition+=" AND langue ='"+str(self.langue.get())+"'"
        condition+=') '
        condition+=" ORDER BY "+self.tri
        res=self.db.select('media',champs,condition)
        self.Resultat(res)

    def Resultat(self,res):
        nbres=len(res)
        go_on=True
        if nbres>100:
            q=dialog.Question(self.top,
                         "Plus de 100 resultats trouvs ("+str(nbres)+")"\
                         +"\nL'affichage risque d'etre trs fortement ralenti"\
                         +"\n Souhaitez vous tout de mme afficher les rsultat ?")
            q.show()
            if bool(q.result):
                go_on=True
            else:
                go_on=False
        if go_on:
            if self.b is not None:
                self.b.pack_forget()
            self.b=Pmw.ScrolledFrame(self.win.pane("resultat"),labelpos = 'n',
                                     label_text = str(nbres)+" rsultat(s) trouvs",
                                     label_foreground='red',label_font=self.gui.config.police_b,)
            self.b.component('frame').pack(expand='yes')
            self.b.pack(side="top",expand="yes",fill="y")
            f=Frame(self.b.interior())
            f.pack(side="top",expand="yes",fill="both")
            #en tete colonnes
            col=['ID','Titre','Auteur','Type','Langue','Sauvegarde','Fichier',\
            'comment']
            colwidth=[4,35,20,14,8,15,30]
            for item in range(0,len(col)-1):
                l=Label(f,text=col[item],anchor=W,justify=LEFT,width=colwidth[item],
                        bg='#EEEEEE',
                        fg="blue",font=self.gui.config.police_b)
                l.pack(side="left",expand="yes",fill="both")
                l.bind("<ButtonPress-1>",
                       lambda event,tri=col[item]:self.Trier(event,tri))
            # bar de progression
            self.avancement=progress.ProgressBar(self.top)
            #remplissage colonnes
            for item in range(nbres):
                avance=float(item+1)/(nbres)*100
                self.avancement.SetProgressPercent(avance)
                self.top.update()
                f=Frame(self.b.interior())
                f.pack(side="top",expand="yes",fill="both")
                if item%2==0:
                    color="#CCCCCC"
                else:
                    color="#DDDDDD"
                for lab in range(0,len(col)-1):
                    l=Label(f,text=str(res[item][lab]),anchor='w',
                            justify='left',
                            highlightbackground='red',
                            width=colwidth[lab],
                            bg=color,
                            font=self.gui.config.police_n)
                    l.pack(side="left",expand="yes",fill="both")
                    l.bind("<ButtonPress-3>",
                           lambda event,id=res[item][0]:self.PopupMenu(event,id))
                    if nbres<100:
                        #au dessus de 100 resultat les balloon font ramer l'appli !
                        txt=str(res[item][7])
                        b=Pmw.Balloon(self.top)
                        b.bind(l,txt)
                        b.component('label').config(font=('Courrier',14,'normal'),
                                                    wraplength=250)
            self.avancement.destroy()
            self.avancement=None        

    def Trier(self,event,tri):
        if self.avancement is None:
            if tri=='ID':
                self.tri='ID'
            elif tri=='Titre':
                self.tri='titre'
            elif tri=='Auteur':
                self.tri='auteur'
            elif tri=='Type':
                self.tri='type'
            elif tri=='Langue':
                self.tri='langue'
            elif tri=='Sauvegarde':
                self.tri='backup'
            elif tri=='Fichier':
                self.tri='fichier'
            self.Rechercher()

    def PopupMenu(self,e,id):
        self.popup = Menu(self.top, tearoff=0)
        self.popup.add_command(label="Afficher",
                               command=lambda item=id:self.AfficherFiche(item))
        self.popup.add_command(label="Modifier",
                               command=lambda item=id:self.ModifierFiche(item))
        self.popup.add_command(label="Supprimer",
                               command=lambda item=id:self.SupprimerFiche(item))
        self.popup.post(e.x_root-5, e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    def Fermer(self):
        if self.avancement is None:
            Media.Fermer(self)

class Media_Afficher(Media):
    """
    Classe d'affichage des documents
    """
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='n',
                    fill='x', padx = 0, pady = 0)
        self.hg=Frame(self.h)
        self.hg.pack(side="left",expand='yes',anchor='n',
                     fill='none', padx = 5, pady = 5)
        self.hd=Frame(self.h)
        self.hd.pack(side="left",expand='yes',anchor='n',
                     fill='none', padx = 5, pady = 5)
        self.b=Frame(self.frame)
        self.b.pack(side="top",expand='yes',anchor='n',
                    fill='x', padx = 5, pady = 5)

    def Afficher(self):
        self.Menu(['modifier','supprimer'])
        self.MiseEnPage()
        self.LireFiche()
        self.AfficherDoc(self.h)

    def AfficherDoc(self,top):
        self.formdocument=Pmw.Group(top,tag_text='Document',
                                     tag_font=self.gui.config.police_i)
        self.formdocument.pack(side="top",padx = 5, pady = 5,expand='no',
                              anchor='n',fill="none")
        labelwidth=12
        entrywidth=50
        f=Frame(self.formdocument.interior())
        f.pack(side='top',expand='yes',fill='none',anchor='w')
        #titre            
        l=Label(f,text=self.titre.get(),anchor='n',width=entrywidth)
        l.pack(side='left',expand='yes',fill='none',anchor='w')
        # type
        if self.type.get()=='Video':
            image=self.pixmap['video']
            txt='Vido'
        elif self.type.get()=='Son':
            image=self.pixmap['audio']
            txt='Audio'
        elif self.type.get()=='Rapport/Memo':
            image=self.pixmap['text']
            txt='Text'
        elif self.type.get()=='Schema':
            image=self.pixmap['schema']
            txt='Schema'
        l=Label(f,image=image,anchor='n',)
        l.pack(side='left',expand='yes',fill='none',anchor='w',padx=10)
        b=Pmw.Balloon(self.top)
        b.bind(l,txt)
        # langue
        if self.langue.get()=='autre':
            pass
        else:
            image=self.pixmap[self.langue.get()]
            l=Label(f,image=image,anchor='n',)
            l.pack(side='left',expand='yes',fill='none',anchor='w',padx=10)        

        f=Frame(self.formdocument.interior())
        f.pack(side='top',expand='yes',fill='none',anchor='w')
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='none',anchor='w')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='none',anchor='w')
        # auteur
        l=Label(fg,text="Auteur :",anchor='e',width=labelwidth,
                font=self.gui.config.police_b)
        l.pack(side='top',expand='yes',fill='none',anchor='w')             
        l=Label(fd,text=self.auteur.get(),anchor='w',
                width=entrywidth)
        l.pack(side='top',expand='yes',fill='none',anchor='w')
        # fichier
        l=Label(fg,text="Fichier :",anchor='e',width=labelwidth,
                font=self.gui.config.police_b)
        l.pack(side='top',expand='yes',fill='none',anchor='w')             
        l=Label(fd,text=self.chemin.get(),anchor='w',
                width=entrywidth)
        l.pack(side='top',expand='yes',fill='none',anchor='w')
        # backup
        l=Label(fg,text="Sauvegarde :",anchor='e',width=labelwidth,
                font=self.gui.config.police_b)
        l.pack(side='top',expand='yes',fill='none',anchor='w')             
        l=Label(fd,text=self.backup.get(),anchor='w',
                width=entrywidth)
        l.pack(side='top',expand='yes',fill='none',anchor='w')
        # resume
        self.formresume=Pmw.Group(top,tag_text='Rsum',
                                     tag_font=self.gui.config.police_i)
        self.formresume.pack(side="top",padx = 5, pady = 5,expand='no',
                              anchor='n',fill="none")
        text=self.comment.get()
        l=Pmw.ScrolledText(self.formresume.interior(),
#                           usehullsize = 1,
                           text_padx=2,
#                           hull_width = 400,
#                           hull_height=200,
                           scrollmargin=0,
                           text_wrap='word',text_bg='#DDDDDD',
                           )
        l.component('text').config(relief='flat')
        l.pack(side="left",expand="no",fill="x",padx=5,pady=5)
        l.settext(re.sub('<br>','\n',text))
        tools.HTMLFormat(l.component('text'),self.gui.config.police_b,
                         self.gui.config.police_i,self.gui.config.police_u)

class Media_Modifier(Media_Ajouter):
    """
    Classe de modification des fiches Photo
    """
    def Afficher(self):
        self.LireFiche()
        self.fichier.set(self.chemin.get())
        Media_Ajouter.Afficher(self)

    def Sauver(self):
        Media_Ajouter.Sauver(self,Modifier=True)

