# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    Classe grant les fiches photo
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

from xml.dom.minidom import parse, getDOMImplementation
from xml.dom.ext import PrettyPrint

from Tkinter import *
import tkFileDialog
import Pmw,re,time,os,shutil
import tools,dialog,mysql,copy,bio,progress

try:
     from PIL import Image, ImageTk
except ImportError:
     import Image, ImageTk



class Photo:
    """
    Classe grant les fiches photo
    Classe drives: Photo_fiche, Photo_geo
    """

    def __init__(self,top,gui):
        self.top=top
        self.gui=gui
        self.fullwindow=False           # fenetre pleine cran ou onlget
        self.file='./geographie.xml'
        self.db=mysql.Mysql(gui.config,self.top)
        self.N1=None                    # Nom du premier niveau de localisation
        self.N3=None                    # Nom du second niveau de localisation
        self.N3=None                    # Nom du troisieme niveau de localisation
        self.N4=None                    # Nom du quatrieme niveau de localisation
        self.geo={}                     # dictionnaire contenant la localisation
        self.N1ordone=[]                # Premier niveau de classification (ordonn)        
        self.Lire()
        self.nivName=[]
        self.nivName.append(self.N1)
        self.nivName.append(self.N2)
        self.nivName.append(self.N3)
        self.nivName.append(self.N4)

    def Lire(self):
        """
        Lit le fichier de localisation
        """
        try:
            dom = parse(self.file)
            top_element=dom.childNodes[0]
        except Exception, error:
            msg="Fichier de localisation '"+str(self.file)+"' illisible !\n"+str(error)
            dialog.Errormsg(self.top,msg).show()
        if top_element.tagName != "GrubsGeo" :
            dialog.Errormsg(self.top,
                           "Fichier de localisation '"+str(self.file)+"' illisible !").show()
        else:
            niveau=top_element.getElementsByTagName("Niveaux")[0]
            self.N1=niveau.getAttribute("N1")
            self.N2=niveau.getAttribute("N2")
            self.N3=niveau.getAttribute("N3")
            self.N4=niveau.getAttribute("N4")
            Niveau1=niveau.getElementsByTagName("N1")
            for niv1 in Niveau1:
                Niveau2=niv1.getElementsByTagName("N2")
                dicn2={}
                for niv2 in Niveau2:
                    dicn3={}
                    Niveau3=niv2.getElementsByTagName("N3")
                    for niv3 in Niveau3:
                        listn4=[]
                        Niveau4=niv3.getElementsByTagName("N4")
                        for niv4 in Niveau4:
                            listn4.append(niv4.childNodes[0].nodeValue)
                        dicn3[niv3.getAttribute("Name")]=listn4
                    dicn2[niv2.getAttribute("Name")]=dicn3
                self.geo[niv1.getAttribute("Name")]=dicn2
                self.N1ordone.append(niv1.getAttribute("Name"))

    def Fermer(self):
        """
        Ferme l'onglet
        """
        if self.fullwindow:
            self.top.destroy()
        else:
            self.gui.Fermer()

    def FermerPopup(self,*e):
        """
        Ferme le popup menu du click droit
        """        
        self.popup.destroy()

    def Menu(self):
        """
        Affiche le menu de la page
        """
        self.menu=Frame(self.top)
        self.menu.pack(side='top',fill='x',expand='no')
        b = Button(self.menu,relief="flat", text='Fermer',compound='left',
			image=self.gui.pixmap['fermer'],
			command=self.Fermer,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)

class Photo_geo(Photo):
    """
    Classe grant la modification de la localisation
    """
            
    def Menu(self):
        """
        Affiche le menu de la page
        """
        Photo.Menu(self)	
	b = Button(self.menu,relief="flat", text='Sauver',compound='left',
			image=self.gui.pixmap['sauver'],
			command=self.Ecrire,overrelief="groove",
			anchor='n')
	b.pack(side="right", padx=10, pady=0)

    def Recharger(self):
        self.menu.destroy()
        self.win.destroy()
        self.Afficher()

    def Afficher(self):
        self.Menu()
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side='top',expand='yes',fill='y')
        self.win.component('frame').pack(expand='yes')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side='top',expand='yes',fill='both',padx=5,pady=5)
        l=Label(self.frame,
                text="Attention: Rglages rservs  un publique avertit !"+\
                "\nToute modification doit tre cohrent avec la base de donne MySQL!",
                fg='#0000AA',font=self.gui.config.police_b,bg='red')
        l.pack(side='top',anchor='nw',expand='yes',fill='both',padx=0)
        for niv1 in range(len(self.N1ordone)):
                niveau1=self.N1ordone[niv1]
                f=Frame(self.frame)
                f.pack(side="top",expand='yes',padx=0,pady=10,anchor='n',fill="x")
                l=Label(f,text=niveau1, anchor='n', justify='left',padx=10,
                        background='#AAAAAA',font=self.gui.config.police_b)
                l.pack(side="top",expand="yes",fill="both")
                l.bind("<ButtonPress-3>",
                       lambda event,niv=1,nom=niveau1,dico=self.geo\
                              :self.PopupMenu(event,nom,dico,niv)) 
                curniv2=0
                for niv2 in self.geo[niveau1].keys():
                        niveau2=self.geo[niveau1][niv2]
                        l=Label(f,text=niv2.encode('latin-1'),height=34,
                                anchor='w', justify='right',padx=0,pady=0,
                                font=self.gui.config.police_n,
                                image=self.gui.pixmap['niv1'],compound='left')
                        l.pack(side="top",expand="no",fill="both",anchor='w')
                        l.bind("<ButtonPress-3>",lambda event,niv=2,
                               dico=self.geo[niveau1],nom=niv2\
                               :self.PopupMenu(event,nom,dico,niv))
                        curniv2=curniv2+1
                        if curniv2==len(self.geo[niveau1]):
                                image=self.gui.pixmap['niv3']
                        else:
                                image=self.gui.pixmap['niv3v']
                        curniv3=0
                        for niv3 in self.geo[niveau1][niv2].keys():
                            niveau3=self.geo[niveau1][niv2][niv3]
                            l=Label(f,height=5,anchor='w', justify='right',padx=0,pady=0,
                                    image=self.gui.pixmap['nivvide'])
                            l.pack(side="top",expand="no",fill="both",anchor='w')
                            l=Label(f,text=niv3.encode('latin-1'),height=34,
                                    anchor='w', justify='right',padx=0,pady=0,
                                    font=self.gui.config.police_n,
                                    image=self.gui.pixmap['niv2'],compound='left')
                            l.pack(side="top",expand="no",fill="both",anchor='w')
                            l.bind("<ButtonPress-3>",lambda event,niv=3,
                                   dico=self.geo[niveau1][niv2],nom=niv3\
                                   :self.PopupMenu(event,nom,dico,niv))
                            curniv3=curniv3+1
                            if curniv3==len(self.geo[niveau1][niv2]):
                                image=self.gui.pixmap['niv3']
                            else:
                                image=self.gui.pixmap['niv3v']
                            for niv4 in range(len(niveau3)):
                                niveau4=self.geo[niveau1][niv2][niv3][niv4]
                                l=Label(f,text=niveau4.encode('latin-1'),
                                        anchor='w', justify='left',height=34,padx=0,pady=0,
                                        font=self.gui.config.police_i,
                                        image=image,compound='left')
                                l.pack(side="top",expand="no",fill="both",anchor='w')
                                l.bind("<ButtonPress-3>",lambda event,niv=4,
                                       dico=self.geo[niveau1][niv2][niv3],
                                       nom=niveau4\
                                       :self.PopupMenu(event,nom,dico,niv))

    def PopupMenu(self,e,nom,dico,niv):
        """
        Definit le Popum menu du click droit
        """
        self.popup = Menu(self.top, tearoff=0)
        if niv<=3:
            self.popup.add_command(label="Ajouter",
                                   command=lambda dico=dico[nom],
                                   niv=niv:self.AddNiv(dico,niv))
        self.popup.add_command(label="Editer",
                               command=lambda nom=nom,dico=dico,
                               niv=niv:self.EditNiv(nom,dico,niv))
        if niv>=2:
                self.popup.add_command(label="Supprimer",
                                  command=lambda nom=nom,dico=dico,
                                  niv=niv:self.DelNiv(nom,dico,niv))
        self.popup.post(e.x_root-5, e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)


    
    def DelNiv(self,nom,dico,niv):
        q=dialog.Question(self.top,"Supprimer :"\
                         +str(nom.encode('latin-1'))+" ?")
        q.show()
        if bool(q.result):
                if niv==2 or niv==3:
                        del dico[nom]
                        self.Recharger()
                elif niv==4:
                        del dico[dico.index(nom)]
                        self.Recharger() 

    def EditNiv(self,nom,dico,niv):
	    msg='Nouveau nom pour '+str(nom.encode('latin-1'))+' ?'
	    d=dialog.Input(self.top,msg)
	    d.show()
	    if d.result==1:
                if niv<=3:
                    if d.input not in dico.keys():
                        dico[d.input]=dico[nom]
                        del dico[nom]
                        if niv==1:
                            item=self.N1ordone.index(nom)
                            self.N1ordone[item]=d.input
                        self.Recharger()
                    else:
                        msg="Ce niveau de localisation existe dja !"
                        dialog.Errormsg(self.top,msg).show()

                elif niv==4:
                    if d.input not in dico:
                        dico[dico.index(nom)]=d.input
                        self.Recharger()				    
                    else:
                        msg="Ce niveau de localisation existe dja !"
                        dialog.Errormsg(self.top,msg).show()

                    
    def AddNiv(self,dico,niv):
        msg='Nom de '+str(self.nivName[niv])+'  ajouter ?'
        d=dialog.Input(self.top,msg)
        d.show()
        if d.result==1:
            if niv==1 or niv==2:
                if d.input not in dico.keys():
                    if niv==1:
                        dico[d.input]={}
                    elif niv==2:
                        dico[d.input]=[]
                    self.Recharger()
                else:
                    msg="Ce niveau de localisation existe dja !"
                    dialog.Errormsg(self.top,msg).show()
            elif niv==3:
                if d.input not in dico:
                    dico.append(d.input)
                    self.Recharger()				    
                else:
                    msg="Ce niveau de localisation existe dja !"
                    dialog.Errormsg(self.top,msg).show()	    

    def Ecrire(self):
        dom = getDOMImplementation()
        doc = dom.createDocument(None, "GrubsGeo", None)
        Node = doc.documentElement
        niveaux= doc.createElement("Niveaux")
        Node.appendChild(niveaux)
        niveaux.setAttribute("N1",self.N1)
        niveaux.setAttribute("N2",self.N2)
        niveaux.setAttribute("N3",self.N3)
        niveaux.setAttribute("N4",self.N4)      
        for niv1 in self.N1ordone:
                n1=doc.createElement("N1")
                niveaux.appendChild(n1)
                niveau1=niv1
                n1.setAttribute("Name",niveau1)
                for niv2 in self.geo[niveau1].keys():
                        niveau2=self.geo[niveau1][niv2]
                        n2=doc.createElement("N2")
                        n1.appendChild(n2)
                        n2.setAttribute("Name",niv2)
                        for niv3 in self.geo[niv1][niv2].keys():
                            niveau3=self.geo[niv1][niv2][niv3]
                            n3=doc.createElement("N3")
                            n2.appendChild(n3)
                            n3.setAttribute("Name",niv3)
                            for niv4 in range(len(niveau3)):
                                niveau4=self.geo[niv1][niv2][niv3][niv4]
                                n4=doc.createElement("N4")
                                n3.appendChild(n4)
                                n4.appendChild(doc.createTextNode(niveau4))
        import shutil
        shutil.copyfile(self.file, "%s.bak" % self.file)
        fid=open(self.file,"w")
        PrettyPrint(doc, fid)
        fid.close()
        dialog.Info(self.top, msg="La nouvelle localisation a t sauvegarde\n"+
		       "Redmarez l'application pour prendre en compte les modifications\n"+
		       "(L'ancien fichier a t copi dans: %s.bak" % self.file).show()
        self.Fermer()


class Photo_Fiche(Photo):
    """
    Classe grant les fiches Photo
    """

    def __init__(self,top,gui,id=None):
        Photo.__init__(self,top,gui)
        self.id=id
        self.niveau1=StringVar()
        self.niveau2=StringVar()
        self.niveau3=StringVar()
        self.niveau4=StringVar()
        self.type=StringVar()
        self.type.set('Bio')
        self.chemin=StringVar()
        self.chemin_org=StringVar()
        self.fichier=StringVar()
	self.backup=StringVar()
        self.commun=[]
        self.latin=[]
	self.image=None
        self.media=StringVar()
        self.media.set('Diapositive')
        self.date=StringVar()
        date=time.localtime()
        self.date.set(str(date[2])+'-'+str(date[1])+'-'+str(date[0]))
        self.comment=None
        self.tri=None
        self.auteur=StringVar()

    def LireFiche(self):
        """
        Charge la fiche photo de la base de donne
        """        
        champs=['fichier','mer','pays','lieu','site','date','type_photo',\
                'comment','chemin','chemin_org','sauvegarde','media','auteur']
        condition="ID='"+str(self.id)+"'"
        res=self.db.select('photo',champs,condition)
        self.fichier.set(res[0][0])
        self.date.set(tools.inverseDate(str(res[0][5])[0:10]))
        self.type.set(res[0][6])
        self.comment=StringVar()
        self.comment.set(res[0][7])
        self.comment.set(tools.filtrehtml(self.comment.get()))
        self.niveau1.set(res[0][1])
        self.niveau2.set(res[0][2])
        self.niveau3.set(res[0][3])
        self.niveau4.set(res[0][4])
        self.chemin.set(res[0][8])
        self.chemin_org.set(res[0][9])
        self.backup.set(res[0][10])
        self.media.set(str(res[0][11]))
        self.auteur.set(str(res[0][12]))
        self.commun=[]
        self.latin=[]
        self.tri=None
        idbio=self.db.Photo2Bio([str(self.id)])
        for item in idbio:
            if item!='':
                commun,latin=self.db.getNoms('Tous','Tous','Tous',id=str(item))
                self.commun.append(commun[1])
                self.latin.append(latin[1])

    def Menu(self,actions):
        Photo.Menu(self)
        if 'vider' in actions:
            b = Button(self.menu,relief="flat", text='Vider',compound='left',
                    image=self.gui.pixmap['vider'],
                    command=self.Vider,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'sauver' in actions:
            b = Button(self.menu,relief="flat", text='Sauver',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Sauver,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'rechercher' in actions:
            b = Button(self.menu,relief="flat", text='Rechercher',compound='left',
                    image=self.gui.pixmap['sauver'],
                    command=self.Rechercher,overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'supprimer' in actions:
            b = Button(self.menu,relief="flat", text='Supprimer',compound='left',
                    image=self.gui.pixmap['supprimer'],
                    command=lambda id=self.id :self.SupprimerFiche(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)
        if 'modifier' in actions:
            b = Button(self.menu,relief="flat", text='Editer',compound='left',
                    image=self.gui.pixmap['editer'],
                    command=lambda id=self.id :self.ModifierFiche(id),overrelief="groove",
                    anchor='n')
            b.pack(side="right", padx=10, pady=0)

    
    def Sauver(self):
        pass

    def Vider(self):
        self.niveau1.set('')
        self.niveau2.set('')
        self.niveau3.set('')
        self.niveau4.set('')
        self.commun=[]
        self.latin=[]
        self.type.set('')
        self.chemin.set('')
        self.chemin_org.set('')
        self.fichier.set('')
        self.backup.set('')
        self.commun=[]
        self.latin=[]
	self.image=None
        self.media.set('')       
        self.date.set('')
        self.comment=None
        self.auteur.set('')

    def SupprimerFiche(self,id):
        q=dialog.Question(self.top,"\nSupprimer la Fiche Photo "+str(id)+" ? \n")
        q.show()
        if bool(q.result):
            res=self.db.SupprimerPhoto(id)
            if res!='error':
                dialog.Info(self.top,"La fiche Photo "+str(id)+" a t supprime\n").show()
        else:
            pass
        return q.result

    def ModifierFiche(self,id):
        self.gui.ModifierPhoto(id)

    def AfficherFiche(self,id):
        self.gui.AfficherPhoto(id)    

    def FormGeo(self,top):
        """
        Affiche le formulaire de selection d'un lieu de plonge
        """
        self.formLocalisation=Pmw.Group(top,tag_text='Localisation',
                                   tag_font=self.gui.config.police_i)
        self.formLocalisation.pack(side="top",padx = 5, pady = 5,expand='yes',
                              anchor='w',fill='both')
        self.FormN1()
        self.FormN2(self.niveau2)
        self.FormN3(self.niveau3)
        self.FormN4(self.niveau4)
        
    def FormN1(self):
        """
        Formulaire pour le niveau 1 de localisation
        """
        self.FormN3Del()
        self.FormN2Del()
        self.FormN1Del()
        self.FormN4Del()
        niv1list=self.N1ordone
        if self.tri is not None:
            niv1list.append('Tous')
        self.formniveau1=Pmw.OptionMenu(self.formLocalisation.interior(), 
                         menubutton_textvariable = self.niveau1,
                         labelpos = 'w',label_text = self.N1+' : ',
                         items = niv1list, label_width=7,
                         command=lambda texte=self.niveau1 :self.FormN2(texte))
        self.formniveau1.component('label').config(anchor='e')
        self.formniveau1.component('menubutton').config(padx=5,pady=3,width=25)
        self.formniveau1.pack(side="top",anchor = 'w', padx = 5, pady = 5,fill="both")

    def FormN2(self,texte):
        """
        Formulaire pour le niveau 2 de localisation
        """            
        self.FormN2Del()
        self.FormN3Del()
        self.FormN4Del()
        if self.niveau1.get() not in ['','Tous']:
            niv2list=self.geo[self.niveau1.get()].keys()
            if self.tri is not None:
                niv2list.append('Tous')
            if self.niveau2.get() not in niv2list:
                self.niveau2.set('')
        else:
            self.niveau2.set('')
            niv2list=[]
        if len(niv2list)==0 or niv2list==['Tous']:
            self.FormN3(self.niveau2)	
        else:
            if len(niv2list)==1:
                self.niveau2.set(niv2list[0])
            self.formniveau2 = Pmw.OptionMenu(self.formLocalisation.interior(), 
                               menubutton_textvariable = self.niveau2,
                               labelpos = 'w',label_text = self.N2+' : ',
                               items = niv2list, label_width=7,
                               command=lambda texte=self.niveau2 :self.FormN3(texte))
            self.formniveau2.component('label').config(anchor='e')
            self.formniveau2.component('menubutton').config(padx=5,pady=3,width=25)
            self.formniveau2.pack(side="top",anchor = 'e', padx = 5, 
                                  pady = 5, fill="both")

    def FormN3(self,texte):
        """
        Formulaire pour le niveau 3 de localisation
        """
        self.FormN3Del()
        self.FormN4Del()	    
        if self.niveau2.get() not in ['','Tous']:
            niv3list=self.geo[self.niveau1.get()][self.niveau2.get()].keys()
            if self.tri is not None:
                niv3list.append('Tous')
            if self.niveau3.get() not in niv3list:
                    self.niveau3.set('')
        else:
            self.niveau3.set('')
            niv3list=[]
        if len(niv3list)==0 or niv3list==['Tous']:
            self.FormN4(self.niveau3)	
        else:
            if len(niv3list)==1:
                self.niveau3.set(niv3list[0])
            self.formniveau3 = Pmw.OptionMenu(self.formLocalisation.interior(), 
                               menubutton_textvariable = self.niveau3,
                               labelpos = 'w',label_text = self.N3+' : ',
                               items = niv3list,label_width=7,
                               command=lambda texte=self.niveau3 :self.FormN4(texte))
            self.formniveau3.component('label').config(anchor='e')
            self.formniveau3.component('menubutton').config(padx=5,pady=3,width=25)            
            self.formniveau3.pack(side="top",anchor='e',padx=5,pady=5,fill="both")

            
    def FormN4(self,texte):
        """
        Formulaire pour le niveau 4 de localisation
        """        
        self.FormN4Del()
        if self.niveau3.get() not in ['','Tous']:
            niv4list=self.geo[self.niveau1.get()][self.niveau2.get()][self.niveau3.get()]
            if self.tri is not None:
                niv4list.append('Tous')
            if self.niveau4.get() not in niv4list:
                self.niveau4.set('')
        else:
            self.niveau4.set('')
            niv4list=[]
        if len(niv4list)==0 or niv4list==['Tous']:
            pass
        else:
            if len(niv4list)==1:self.niveau4.set(niv4list[0])
            self.formniveau4 = Pmw.OptionMenu(self.formLocalisation.interior(), 
                               menubutton_textvariable = self.niveau4,label_width=7,
                               labelpos = 'w',label_text = self.N4+' : ',
                               items = niv4list)
            self.formniveau4.component('label').config(anchor='e')
            self.formniveau4.component('menubutton').config(padx=5,pady=3,width=25)              
            self.formniveau4.pack(side="top",anchor='w',padx=5,pady=5,fill="both")

    def FormN1Del(self):
        try:
            self.formniveau1.pack_forget()
            self.niveau1=StringVar()
        except:
            pass
            
    def FormN2Del(self):
        try:
            self.formniveau2.pack_forget()
            self.niveau2=StringVar()
        except:
            pass

    def FormN3Del(self):
        try:
            self.formniveau3.pack_forget()
            self.niveau3=StringVar()
        except:
            pass

    def FormN4Del(self):
        try:
            self.formniveau4.pack_forget()
            self.niveau4=StringVar()
        except:
            pass

    def FormComment(self,top):
        self.formcomment=Pmw.Group(top,tag_text='Commentaires',
                                   tag_font=self.gui.config.police_i)
        self.formcomment.pack(side="top",padx = 5, pady = 5,expand='yes',
                              anchor='w',fill="both")

    def SetMedia(self,tag):
        self.media.set(str(tag))

    def SetType(self,tag):
        self.type.set(str(tag))

class Photo_Fiche_Ajouter(Photo_Fiche):
    """
    Classe d'ajout des fiches Photo
    """
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='n',
                    fill='x', padx = 0, pady = 0)
        self.hg=Frame(self.h)
        self.hg.pack(side="left",expand='yes',anchor='n',
                     fill='x', padx = 5, pady = 5)
        self.hd=Frame(self.h)
        self.hd.pack(side="left",expand='yes',anchor='n',
                     fill='x', padx = 5, pady = 5)
        self.b=Frame(self.frame)
        self.b.pack(side="top",expand='yes',anchor='n',
                    fill='both', padx = 5, pady = 5)       

    def Afficher(self):
        self.Menu(['sauver','vider'])
        self.MiseEnPage()
        self.FormGeo(self.hg)
        self.FormIdentification(self.hg)
        self.FormComment(self.hg)
        self.FormGeneral(self.hd)

    def FormIdentification(self,top):
        """
        Affiche les formulaire pour identifier les photo bio
        """
        self.formident=Pmw.Group(self.hg,tag_text='Identification',
                                          tag_font=self.gui.config.police_i)
        self.formident.pack(side="top",padx = 5, pady = 5,expand='yes',
                                     anchor='w',fill="both")
        commun,latin=self.db.getNoms('Tous','Tous','Tous')
        self.formidentcommun=Pmw.ScrolledListBox(self.formident.interior(),
                                                 items=commun,listbox_height = 10,
                                                 selectioncommand=self.SetCommun,
                                                 listbox_selectmode = 'multiple',
                                                 )
        self.formidentcommun.pack(side="top",anchor = 'w', padx = 5, pady = 5,
                                  fill="both",expand='yes')
##        if len(self.commun)!=0:
##            noms=[]
##            for item in self.commun:
##                noms.append(item)
        self.formidentcommun.setvalue(self.commun)
##        self.formidentlatin=Pmw.ScrolledListBox(self.formident.interior(),
##                                                items=latin,listbox_height = 10,
##                                                selectioncommand=self.SetLatin,
##                                                listbox_selectmode = 'multiple',)
##        self.formidentlatin.pack(side="top",anchor = 'w', padx = 5, pady = 5,
##                                 fill="both",expand='yes')

    def SetCommun(self):
        self.commun=self.formidentcommun.getvalue()

##   def SetLatin(self):
##        print '*** SetLatin ***'
##        self.latin=self.formidentlatin.getvalue()
##        print self.latin
##        index=self.formidentlatin.component('listbox').curselection()
##        print index
##        for item in index:
##            self.formidentcommun.component('listbox').select_set(item)
##        self.commun=self.formidentcommun.getvalue()

    def FormComment(self,top):
        Photo_Fiche.FormComment(self,top)
        if self.comment is not None:
            comment=self.comment.get()
        else:
            comment=''
        self.comment=Pmw.ScrolledText(self.formcomment.interior(),text_padx = 0,
                                      text_pady = 4,usehullsize = 1,hull_width = 270,
                                      hull_height = 100,text_wrap='word')
        self.comment.pack(side="top",padx=0,pady=5)
        self.comment.settext(comment)        

    def FormGeneral(self,top):
        self.formgeneral=Pmw.Group(top,tag_text='Gnralits',
                                   tag_font=self.gui.config.police_i)
        self.formgeneral.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='n',fill="x")
        # premiere ligne
        f=Frame(self.formgeneral.interior())
        f.pack(side="top",expand="yes",fill="x",anchor='w',padx=5,pady=5)
        # chemin
        e=Pmw.EntryField(f,labelpos='w',label_text='Chemin : ',entry_textvariable=self.chemin)
        e._entryFieldEntry.grid(sticky ='w')
        e._entryFieldEntry.config(width=30)
        e.pack(side="left",fill="both",expand="yes",padx=3,pady=3,anchor='w')
        b=Button(f, text='...', command=self.OuvrirPhoto)
        b.pack(side='left',fill='both',padx=10,pady=5)
        # sauvegarde
        e=Pmw.EntryField(f,labelpos='w',label_text='Sauvegarde: ',
                         entry_textvariable=self.backup,)
        e.pack(side="left",fill="both",expand="yes",padx=3,pady=3,anchor='e')
        e._entryFieldEntry.grid(sticky ='e')
        e._entryFieldEntry.config(width=20)
        # deuxime ligne
        f=Frame(self.formgeneral.interior())
        f.pack(side="top",expand='yes',anchor='w',fill="x",padx=5,pady=5)
        # date
        e=Pmw.EntryField(f,labelpos='w',label_text='Date (jj-mm-aaaa): ',
                         entry_textvariable=self.date,
                         validate = {'validator' : 'date','format' : 'dmy', 'separator' : '-'})
        e._entryFieldEntry.config(width=10)
        e._entryFieldEntry.grid(sticky ='w')
        e.pack(side="left",anchor='n',fill="both",expand="no",padx=3,pady=3)
        # media
        liste=['Diapositive','Ngatif','Numrique','']
        l=Pmw.OptionMenu(f,
                         labelpos = 'w',label_text = 'Mdia : ',
                         items = liste,
                         initialitem=self.media.get(),
                         command=self.SetMedia)
        l.component('menubutton').config(padx=5,pady=3,width=10)        
        l.pack(side="left",anchor='n',fill="both",expand="no",padx=25,pady=3)
        # type
        liste=['Bio','Ambiance','']
        l=Pmw.OptionMenu(f,
                         labelpos = 'w',label_text = 'Type : ',
                         items = liste,
                         initialitem=self.type.get(),
                         command=self.SetType)
        l.component('menubutton').config(padx=5,pady=3,width=10)         
        l.pack(side="left",anchor='n',fill="both",expand="no",padx=3,pady=3)

    def OuvrirPhoto(self,file=None):
        if file is None:
                 file=tkFileDialog.askopenfilename()
        if file==():
            pass
	else:
	    self.chemin.set(file)
	    image=Image.open(self.chemin.get())
	    self.image=ImageTk.PhotoImage(tools.redim(image,(450,370)))
	    self.FormImage()

    def FormImage(self):
        if self.image is not None:
            try:
                self.formimage.destroy()
            except:
                pass
            self.formimage=Pmw.Group(self.hd,tag_text='Photo',
                                     tag_font=self.gui.config.police_i)
            self.formimage.pack(side="top",padx = 5, pady = 5,expand='yes',
                                anchor='n',fill="x")
            l=Label(self.formimage.interior(),image=self.image)
            l.pack(side='top',padx = 10, pady = 10,expand='yes',anchor='w',fill="x")
            e=Pmw.EntryField(self.formimage.interior(),labelpos='w',
                             label_text='Photographe: ',
                             entry_textvariable=self.auteur,)
            e.pack(side="left",fill="both",expand="yes",padx=3,pady=3,anchor='w')
            e._entryFieldEntry.grid(sticky ='w')
            e._entryFieldEntry.config(width=20)

    def Sauver(self,Modifier=False):
        go_on=True
        if self.niveau1.get() =='':
            e=dialog.Errormsg(self.top,"Choisissez au moins une Mer !")
            e.show()
            go_on=False
        else:
            self.chemin_org.set(self.chemin.get())
            self.fichier.set(os.path.basename(self.chemin_org.get()))
            image=Image.open(self.chemin_org.get())
            max_comp=eval(self.gui.config.photo_comp.get())
            if self.gui.config.photo_copier:
                self.chemin.set(str(self.gui.config.photo_rep.get())+'/'+str(self.fichier.get()))
            else:
                self.chemin.set(self.chemin_org.get())
            if not Modifier:
                exist,id=self.db.ElementExist('photo',"chemin=\""+str(self.chemin.get())+"\"")
                while exist:
                    if self.gui.config.photo_copier:
                        liste=['Remplacer','Modifier nom','Annuler']
                    else:
                        liste=['Remplacer','Annuler']
                    q=dialog.Liste(self.top,"Une fiche avec le mme non de fichier photo existe dj"+\
                                            "\nQue voulez vous faire ?",liste)
                    q.show()
                    if q.result=='Remplacer':
                        Modifier=True
                        self.id=str(id)
                        exist=False
                    elif q.result=='Modifier nom':
                        d=dialog.Input(self.top,"Nouveau nom pour le fichier "+\
                                       str(self.fichier.get()))
                        d.show()
                        if d.result:
                            self.fichier.set(d.input)
                            self.chemin.set(str(self.gui.config.photo_rep.get())+'/'+str(self.fichier.get()))
                            exist,id=self.db.ElementExist('photo',"chemin=\""+str(self.chemin.get())+"\"")
                        else:
                            go_on=False
                            exist=False
                    else:
                        go_on=False
                        exist=False
            else:
                go_on=True
                exist=False
        if go_on and self.gui.config.photo_copier:
            # generation de la copie local de la photo  
            max_larg=eval(self.gui.config.photo_larg.get())
            max_haut=eval(self.gui.config.photo_haut.get())
            size_org=image.size
            if size_org[0]>max_larg or size_org[1]>max_haut:
                 image=tools.redim(image,(max_larg,max_haut),alias=True)
                 try:
                      image.save(self.chemin.get(),quality=max_comp,optimize=1)
                 except IOError: 
                      image.save(self.chemin.get(),quality=max_comp)
            else:
                try:
                    shutil.copyfile(self.chemin_org.get(),self.chemin.get())
                except:
                    e=dialog.Errormsg(self.top,"Le fichier choisi est dj fichier local  GRUBS !\nImpossible d'en faire une copie locale !\nLa modification n'a pas t prise en compte.")
                    e.show()
                    go_on=False                   
        if go_on:
            # generation de la miniature
            mini_larg=eval(self.gui.config.mini_larg.get())
            mini_haut=eval(self.gui.config.mini_haut.get())
            miniature_path='./miniature/'+str(self.fichier.get())
            miniature=tools.redim(image,(mini_larg,mini_haut))
            try:
                miniature.save(miniature_path,quality=max_comp,optimize=1)
            except:
                miniature.save(miniature_path,quality=max_comp)            
            # ajout de la photo dans la base de donne
            elements=[]
            elements.append("chemin_org=\""+tools.nettoyer(self.chemin_org.get())+"\"")
            elements.append("chemin=\""+tools.nettoyer(self.chemin.get())+"\"")
            elements.append("sauvegarde=\""+tools.nettoyer(self.backup.get())+"\"")
            elements.append("media=\""+tools.nettoyer(self.media.get())+"\"")
            elements.append("comment=\""+tools.add_br(tools.nettoyer(self.comment.get()[:-1]))+"\"")
            elements.append("type_photo=\""+tools.nettoyer(self.type.get())+"\"")
            elements.append("date=\""+str(tools.inverseDate(self.date.get()))+"\"")
            elements.append("site=\""+tools.nettoyer(self.niveau4.get())+"\"")
            elements.append("lieu=\""+tools.nettoyer(self.niveau3.get())+"\"")
            elements.append("pays=\""+tools.nettoyer(self.niveau2.get())+"\"")
            elements.append("mer=\""+tools.nettoyer(self.niveau1.get())+"\"")
            elements.append("fichier=\""+tools.nettoyer(self.fichier.get())+"\"")
            elements.append("auteur=\""+tools.nettoyer(self.auteur.get())+"\"")
            if not Modifier:            
                res,id=self.db.ajouter('photo',elements)
                self.id=str(id)
            else:
                res=self.db.modifier('photo',elements,str(self.id))
                #supprime les ancioen lien bio
                res=self.db.SupprimerLienPhoto(str(self.id))
            # ajout des liens vers la bio
            for item in self.commun:
                element='commun="'+str(item)+'"'
                id=self.db.GetID('bio',element)
                lien=[]
                lien.append('IDbio="'+str(id)+'"')
                lien.append('IDphoto="'+str(self.id)+'"')
                res,id=self.db.ajouter('bio_photo',lien)
            if res!='error' and not Modifier:
                i=dialog.Info(self.top,"La photo: "+str(self.chemin_org.get())+" a t ajoute")
                i.show()
            elif res!='error' and Modifier:
                i=dialog.Info(self.top,"La photo: "+str(self.chemin_org.get())+" a t modifie")
                i.show()
            
class Photo_Fiche_Rechercher(Photo_Fiche):
    """
    Classe de recherche de fiches photo
    """
    def __init__(self,top,gui):
        Photo_Fiche.__init__(self,top,gui,None)
        self.tri='date'
        self.type.set('Tous')
        self.media.set('Tous')
        self.comment=StringVar()
        self.avancement=None
        self.ObjetBio=bio.Bio_Fiche_Rechercher(top,gui)
        self.dateapres=StringVar()
        self.dateavant=StringVar()

    def MiseEnPage(self):
        self.win=Pmw.PanedWidget(self.top,orient='vertical')
        self.win.pack(side="top",fill="both",expand="yes")
        self.win.add('recherche',min=0)
        self.win.add('resultat',min=0)
        self.h=Pmw.ScrolledFrame(self.win.pane("recherche"))
        self.h.pack(side="top",expand="yes",fill="y")
        self.h.component('frame').pack(expand='yes')
        self.hg=Frame(self.h.interior())
        self.hg.pack(side='left',expand='yes',fill='x',anchor='n')
        self.hm=Frame(self.h.interior())
        self.hm.pack(side='left',expand='yes',fill='x',anchor='n')
        self.hd=Frame(self.h.interior())
        self.hd.pack(side='left',expand='yes',fill='x',anchor='n')
        self.b=None
  
    def Vider(self):
        self.ObjetBio.Vider()
        Photo_Fiche.Vider(self)
        self.comment.set('')
        self.media.set('Tous')
        self.type.set('Tous')
        self.FormN1()
        try:
            self.b.destroy()
        except:
            pass
        
    def Afficher(self):
        self.Menu(['rechercher','vider'])
        self.MiseEnPage()
        self.FormPhoto()
        self.FormBio()
        self.FormText()
        self.FormTypeRes()

    def FormPhoto(self):
        self.formphoto=Pmw.Group(self.hg,tag_text='Photo',
                                 tag_font=self.gui.config.police_bi)
        self.formphoto.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='n',fill="x")
        self.FormGeneral(self.formphoto.interior())
        self.FormGeo(self.formphoto.interior())


    def FormBio(self):
        self.formbio=Pmw.Group(self.hm,tag_text='Bio',
                               tag_font=self.gui.config.police_bi)
        self.formbio.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='n',fill="x")
        self.ObjetBio.formnom=Pmw.Group(self.formbio.interior(),tag_text='Noms',tag_font=self.gui.config.police_i)
        self.ObjetBio.formnom.pack(side="bottom",padx = 5, pady = 5,expand='yes',anchor='w',fill="both")
        self.ObjetBio.FormNom(self.ObjetBio.formnom.interior(),side='top')
        self.ObjetBio.FormClassif(self.formbio.interior())


    def FormText(self):
        self.formtext=Pmw.Group(self.hd,tag_text='Text',
                                tag_font=self.gui.config.police_bi)
        self.formtext.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='n',fill="x")        
        e=Pmw.EntryField(self.formtext.interior(),labelpos='nw',
                         label_text='Contient (wildcard: %) : ',
                         entry_textvariable=self.comment, )
        e._entryFieldEntry.grid(sticky='w')
        e._entryFieldEntry.config(width='35')
        e.pack(side="left",fill="none",expand="no",padx=3,pady=3)

    def FormTypeRes(self):
        self.formtyperes=Pmw.Group(self.hd,tag_text='Resultat',
                                   tag_font=self.gui.config.police_bi)
        self.formtyperes.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='n',fill="x")        
        r = Pmw.RadioSelect(self.formtyperes.interior(),buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checkres,label_text = 'Affichage :',
                            label_width='10',label_anchor='e')
        r.pack(side = 'top', expand = 'yes', padx = 0, pady = 0, anchor='w')
        r.add('Liste')
        r.add('Vignettes')
        r.invoke('Liste')
        r = Pmw.RadioSelect(self.formtyperes.interior(),buttontype = 'radiobutton',labelpos = 'w',
                            command = self.checkexp,label_text = 'Exporter :',
                            label_width='10',label_anchor='e')
        r.pack(side = 'top', expand = 'yes', padx = 0, pady = 0,anchor='w')
        r.add('Oui')
        r.add('Non')
        r.invoke('Non')        

    def checkexp(self,tag):
        if tag=='Oui':
            self.resexport=True
        else:
            self.resexport=False
         
    def checkres(self,tag):
        if tag=='Liste':
            self.resliste=True
        else:
            self.resliste=False

    def FormGeneral(self,top):
        self.formgeneral=Pmw.Group(top,tag_text='Gnralits',
                                   tag_font=self.gui.config.police_i)
        self.formgeneral.pack(side="top",padx = 5, pady = 0,expand='yes',anchor='n',fill="x")
        f=Frame(self.formgeneral.interior())
        f.pack(side='top',anchor='n',fill='both',expand='no',padx=0,pady=0)
        # media
        liste=['Diapositive','Ngatif','Numrique','Tous']
        l=Pmw.OptionMenu(f,
                         labelpos = 'w',label_text = 'Mdia : ',
                         items = liste,
                         initialitem='Tous',
                         command=self.SetMedia)
        l.component('menubutton').config(padx=0,pady=3,width=10)
        l.component('label').config(padx=0,pady=3,width=7)
        l.pack(side="left",anchor='w',fill="none",expand="no",padx=1,pady=3)
        # type
        liste=['Bio','Ambiance','Tous']
        l=Pmw.OptionMenu(f,
                         labelpos = 'w',label_text = 'Type : ',
                         items = liste,
                         initialitem='Tous',
                         command=self.SetType)
        l.component('menubutton').config(padx=0,pady=3,width=9)
        l.component('label').config(padx=0,pady=3,width=7)
        l.pack(side="left",anchor='w',fill="none",expand="no",padx=0,pady=3)
        # date
        f=Frame(self.formgeneral.interior())
        f.pack(side='top',anchor='n',fill='both',expand='no',padx=0,pady=0)
        e=Pmw.EntryField(f,entry_textvariable=self.dateapres,
                         validate = {'validator' : 'date','format' : 'dmy', 'separator' : '-'})
        e._entryFieldEntry.config(width=10)
        e._entryFieldEntry.grid(sticky ='w')
        e.pack(side="left",fill="none",expand="yes",padx=0,pady=3,anchor='w')
        l=Label(f,text='< Date (jj-mm-aaaa) <')
        l.pack(side="left",anchor='n',fill="both",expand="no",padx=0,pady=3)
        e=Pmw.EntryField(f,entry_textvariable=self.dateavant,
                         validate = {'validator' : 'date','format' : 'dmy', 'separator' : '-'})
        e._entryFieldEntry.config(width=10)
        e._entryFieldEntry.grid(sticky ='w')
        e.pack(side="left",fill="none",expand="yes",padx=0,pady=3,anchor='w')

    def Rechercher(self):
        if self.avancement is None:
            # recherche bio (uniquement si des critres bio sont slectionns
            self.ObjetBio.comment.set(self.comment.get())
            if self.ObjetBio.CriteresBio():
                idbio=self.ObjetBio.Rechercher(Afficher=False)
                idphoto=self.db.Bio2Photo(idbio)
            else:
                idphoto=None
            # recherche photo
            champs=['ID','mer','pays','lieu','site','date','fichier','type_photo',\
                    'media','sauvegarde','chemin','chemin_org','auteur']
            condition='(1 '
            if self.niveau1.get() not in ['','Tous']:
                 condition+=" AND mer ='"+tools.nettoyer(self.niveau1.get())+"'"
            if self.niveau2.get() not in ['','Tous']:
                 condition+=" AND pays ='"+tools.nettoyer(self.niveau2.get())+"'"
            if self.niveau3.get() not in ['','Tous']:
                 condition+=" AND lieu ='"+tools.nettoyer(self.niveau3.get())+"'"
            if self.niveau4.get() not in ['','Tous']:
                 condition+=" AND site ='"+tools.nettoyer(self.niveau4.get())+"'"
            if self.type.get() !='Tous':
                 condition+=" AND type_photo ='"+str(self.type.get())+"'"
            if self.media.get() !='Tous':
                 condition+=" AND media ='"+str(self.media.get())+"'"
            if self.dateavant.get() !='':
                 condition+=" AND date<='"+tools.inverseDate(self.dateavant.get())+"'"
            if self.dateapres.get() !='':
                 condition+=" AND date>='"+tools.inverseDate(self.dateapres.get())+"'"    
            condition+=') '
            text=tools.nettoyer(self.comment.get())
            if len(text)>3:
                condition+=" AND (comment LIKE '%"+str(text)+"%'"
                condition+=" OR sauvegarde LIKE '%"+str(text)+"%'"
                condition+=" OR auteur LIKE '%"+str(text)+"%'"
                condition+=" OR fichier LIKE '%"+str(text)+"%'"
                if self.niveau1.get() in ['','Tous']:
                    condition+=" OR mer LIKE '%"+str(text)+"%'"
                if self.niveau2.get() in ['','Tous']:
                    condition+=" OR pays LIKE '%"+str(text)+"%'"
                if self.niveau3.get() in ['','Tous']:
                    condition+=" OR lieu LIKE '%"+str(text)+"%'"
                if self.niveau4.get() in ['','Tous']:
                    condition+=" OR site LIKE '%"+str(text)+"%'"
                condition+=' ) '
            condition+=" ORDER BY "+self.tri
            res=self.db.select('photo',champs,condition)
            result=[]
            for item in res:
                if idphoto is None or str(item[0]) in idphoto:
                    result.append(item)
            if self.resexport:
                self.ExportResultat(result)
            else:
                self.Resultat(result)
            
    def ExportResultat(self,res):
        file=tkFileDialog.asksaveasfilename(title="Fichier MySQL",
                                            filetypes=[("MySQL file",".sql")])
        if file==():
            pass
        else:
            fid=open(file,'w')
            self.db.connect()
            idphoto=[]
            idphoto.append(str(res[0][0]))
            condition_photo='( ID='+str(res[0][0])
            condition_biophoto='( IDphoto='+str(res[0][0])
            for item in range(len(res)-1):
                condition_photo+=' OR ID ='+str(res[item+1][0])
                condition_biophoto+=' OR IDphoto='+str(res[item+1][0])
                idphoto.append(str(res[item+1][0]))
            condition_photo+=' )'
            condition_biophoto+=' )'
            self.db.dump_data_sql(fid,'photo',condition=condition_photo)
            self.db.dump_data_sql(fid,'bio_photo',condition=condition_biophoto)
            idbio=self.db.Photo2Bio(idphoto)
            self.db.connect()
            condition_bio='( ID='+str(idbio[0])
            for item in range(len(idbio)-1):
                condition_bio+=' OR ID ='+str(idbio[item+1])
            condition_bio+=' )'
            self.db.dump_data_sql(fid,'bio',condition=condition_bio)
            self.db.deconnect
            i=dialog.Info(self.top,str(len(res))+" rsultats exports")
            i.show()

    def Resultat(self,res):
        nbres=len(res)
        go_on=True
        if nbres>100:
            q=dialog.Question(self.top,
                         "Plus de 100 resultats trouvs ("+str(nbres)+")"\
                         +"\nL'affichage risque d'etre trs fortement ralenti"\
                         +"\n Souhaitez vous tout de mme afficher les rsultat ?")
            q.show()
            if bool(q.result):
                go_on=True
            else:
                go_on=False
        if go_on:
            if self.b is not None:
                self.b.pack_forget()
            self.b=Pmw.ScrolledFrame(self.win.pane("resultat"),labelpos = 'n',
                                     label_text = str(nbres)+" rsultat(s) trouvs",
                                     label_foreground='red',label_font=self.gui.config.police_b,)
            self.b.component('frame').pack(expand='yes')
            self.b.pack(side="top",expand="yes",fill="y")
            f=Frame(self.b.interior())
            f.pack(side="top",expand="yes",fill="both")
            #en tete colonnes
            if self.resliste:
                col=['ID',self.N1,self.N2,self.N3,self.N4,'Date','Fichier']
                colwidth=[4,30,12,20,20,12,18]
                for item in range(0,len(col)):
                    l=Label(f,text=col[item], anchor=W, justify=LEFT,
                            width=colwidth[item],bg='#EEEEEE',
                            fg="blue",font=self.gui.config.police_b)
                    l.pack(side="left",expand="yes",fill="both")
                    l.bind("<ButtonPress-1>",
                           lambda event,tri=col[item]:self.Trier(event,tri))
                # bar de progression
                self.avancement=progress.ProgressBar(self.top)
                #remplissage colonnes
                for item in range(nbres):
                    avance=float(item+1)/(nbres)*100
                    self.avancement.SetProgressPercent(avance)
                    self.top.update()
                    f=Frame(self.b.interior())
                    f.pack(side="top",expand="yes",fill="both")
                    if item%2==0:
                        color="#CCCCCC"
                    else:
                        color="#DDDDDD"
                    for lab in range(0,len(col)):
                        texte=str(res[item][lab])
                        if lab==5:
                            texte=texte[:10]
                        l=Label(f,text=texte, anchor=W, justify=LEFT,
                                width=colwidth[lab],bg=color,
                                font=self.gui.config.police_n)
                        l.pack(side="left",expand="yes",fill="both")
                        l.bind("<ButtonPress-3>",
                               lambda event,id=res[item][0]:self.PopupMenu(event,id))
                        if nbres<100:
                            #au dessus de 100 resultat les balloon font ramer l'appli !
                            txt=   "ID              :"+str(res[item][0])
                            txt+="\nDate            :"+str(tools.inverseDate(str(res[item][5])[:10]))
                            txt+="\nauteur          :"+str(res[item][12])
                            txt+="\nFichier         :"+str(res[item][6])
                            txt+="\n"+str(self.N1)+"             :"+str(res[item][1])
                            txt+="\n"+str(self.N2)+"            :"+str(res[item][2])
                            txt+="\n"+str(self.N3)+"            :"+str(res[item][3])
                            txt+="\n"+str(self.N4)+"            :"+str(res[item][4])
                            txt+="\nType photo      :"+str(res[item][7])
                            txt+="\nMedia           :"+str(res[item][8])
                            txt+="\nSauvegarde      :"+str(res[item][9])
                            b=Pmw.Balloon(self.top)
                            b.bind(l,txt)
                            b.component('label').config(font=('Courrier',14,'normal'))
                self.avancement.destroy()
                self.avancement=None        
            else:
                fichiers=[]
                for item in range(nbres):
                    if os.path.isfile('./miniature/'+str(res[item][6])):
                        fichiers.append('./miniature/'+str(res[item][6]))
                    else:
                        fichiers.append('./pixmap/mininotfound.jpg')

                labelwidth=eval(self.gui.config.mini_larg.get())+10
                labelheight=eval(self.gui.config.mini_haut.get())+10
                nb_mini=eval(self.gui.config.mini_nb.get())
                self.listemini=[]
                nb=1
                # bar de progression
                self.avancement=progress.ProgressBar(self.top)                
                for item in range(nbres):
                    if nb>nb_mini:
                        f=Frame(self.b.interior(),padx=5,pady=5)
                        f.pack(side="top",expand="yes",fill="x")
                        nb=1
                    photo=Image.open(fichiers[item])
                    photo=ImageTk.PhotoImage(photo)
                    self.listemini.append(photo)
                    l=Label(f,image=photo,width=labelwidth,
                            height=labelheight,relief='raised')
                    l.pack(side='left',padx = 10,
                           pady = 10,expand='no',anchor='w',fill="none")
                    l.bind("<ButtonPress-3>",lambda event,idphoto=str(res[item][0]):\
                                                    self.PopupMenu(event,idphoto))
                    nb+=1
                    if nbres<100:
                        #au dessus de 100 resultat les balloon font ramer l'appli !                        
                        txt=   "ID              :"+str(res[item][0])
                        txt+="\nDate            :"+str(tools.inverseDate(str(res[item][5])[:10]))
                        txt+="\nauteur          :"+str(res[item][12])
                        txt+="\nFichier         :"+str(res[item][6])                        
                        txt+="\n"+str(self.N1)+"             :"+str(res[item][1])
                        txt+="\n"+str(self.N2)+"            :"+str(res[item][2])
                        txt+="\n"+str(self.N3)+"            :"+str(res[item][3])
                        txt+="\n"+str(self.N4)+"            :"+str(res[item][4])
                        txt+="\nType photo      :"+str(res[item][7])
                        txt+="\nMedia           :"+str(res[item][8])
                        txt+="\nSauvegarde      :"+str(res[item][9])
                        b=Pmw.Balloon(self.top)
                        b.bind(l,txt)
                        b.component('label').config(font=('Courrier',14,'normal'))
                self.avancement.destroy()
                self.avancement=None

    def PopupMenu(self,e,id):
        self.popup = Menu(self.top, tearoff=0)
        self.popup.add_command(label="Afficher",
                               command=lambda item=id:self.AfficherFiche(item))
        self.popup.add_command(label="Modifier",
                               command=lambda item=id:self.ModifierFiche(item))
        self.popup.add_command(label="Supprimer",
                               command=lambda item=id:self.SupprimerFiche(item))
        self.popup.post(e.x_root-5, e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    def Trier(self,event,tri):
        if self.avancement is None:
            if tri==str(self.N1):
                self.tri='mer'
            elif tri==str(self.N2):
                self.tri='pays'
            elif tri==str(self.N3):
                self.tri='lieu'
            elif tri==str(self.N4):
                self.tri='site'
            elif tri=='Date':
                self.tri='date'
            elif tri=='Fichier':
                self.tri='fichier'
            elif tri=='ID':
                self.tri='ID'
            self.Rechercher()
            
    def Fermer(self):
        if self.avancement is None:
            Photo.Fermer(self)

class Photo_Fiche_Afficher(Photo_Fiche):
    """
    Classe d'affichage des fiches photo
    """
    def MiseEnPage(self):
        self.win=Pmw.ScrolledFrame(self.top)
        self.win.pack(side="top",expand="yes",fill="both",anchor='n')
        self.frame=Frame(self.win.interior())
        self.frame.pack(side="top",fill="both",anchor='n')
        self.h=Frame(self.frame)
        self.h.pack(side="top",expand='yes',anchor='n',
                    fill='x', padx = 0, pady = 0)
        self.hg=Frame(self.h)
        self.hg.pack(side="left",expand='yes',anchor='n',
                     fill='none', padx = 5, pady = 5)
        self.hd=Frame(self.h)
        self.hd.pack(side="left",expand='yes',anchor='n',
                     fill='none', padx = 5, pady = 5)
        self.b=Frame(self.frame)
        self.b.pack(side="top",expand='yes',anchor='n',
                    fill='x', padx = 5, pady = 5) 
        
    def Afficher(self):
        self.Menu(['modifier','supprimer'])
        self.MiseEnPage()
        self.LireFiche()
        self.AfficherImage(self.hg)
        self.AfficherGeo(self.hd)
        self.AfficherGeneral(self.hd)
        self.AfficherComment(self.hd)
        idbio=self.db.Photo2Bio([str(self.id)])
        for item in idbio:
            self.AfficherBio(self.b,item)

    def AfficherImage(self,top):
        if os.path.isfile(str(self.chemin.get())):
            fichier=self.chemin.get()
        else:
            i=dialog.Info(self.top,
                          "Le fichier de copie locale de la photo est introuvable !"+\
                          "\nChoisisser modifier et corrigez le nom du fichier!")
            i.show()
            fichier='./pixmap/photonotfound.jpg'
        image=Image.open(fichier)
        self.image=ImageTk.PhotoImage(image)
        self.formimage=Pmw.Group(top,tag_text='Photo',tag_font=self.gui.config.police_i)
        self.formimage.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="x")
        l=Label(self.formimage.interior(),image=self.image)
        l.pack(side='top',padx = 10, pady = 10,expand='yes',anchor='w',fill="x")
        max_larg=eval(self.gui.config.photo_larg.get())
        max_haut=eval(self.gui.config.photo_haut.get())
        size=image.size
        if size[0]>max_larg:
            l.config(width=max_larg)
        elif size[1]>max_haut:
            l.config(height=max_height)
        f=Frame(self.formimage.interior())
        f.pack(side='top',expand='yes',fill='none',anchor='w')
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='none',anchor='w')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='none',anchor='w')
        l=Label(fg,text="Photo originale :",anchor='e',width=14,font=self.gui.config.police_b)
        l.pack(side='top',expand='yes',fill='none',anchor='w')             
        l=Label(fd,text=self.chemin_org.get(),anchor='w')
        l.pack(side='top',expand='yes',fill='none',anchor='w')
        if self.gui.config.photo_copier:
            l=Label(fg,text="Copie locale :",anchor='e',width=14,font=self.gui.config.police_b)
            l.pack(side='top',expand='yes',fill='none',anchor='w')             
            l=Label(fd,text=self.chemin.get(),anchor='w')
            l.pack(side='top',expand='yes',fill='none',anchor='w')
        l=Label(fg,text="Photographe :",anchor='e',width=14,font=self.gui.config.police_b)
        l.pack(side='top',expand='yes',fill='none',anchor='w')             
        l=Label(fd,text=self.auteur.get(),anchor='w')
        l.pack(side='top',expand='yes',fill='none',anchor='w')        
            
    def AfficherGeo(self,top):
        labelwidth=7
        entrywidth=30
        wrapwidth=150
        g=Pmw.Group(top,tag_text='Localisation',tag_font=self.gui.config.police_i)
        g.pack(side="top",padx = 5, pady = 5,expand='no',anchor='w',fill='none')
        f=Frame(g.interior())
        f.pack(side="top",expand="yes",fill="both",padx=5,pady=5)
        l=Label(f,text=self.N1+" : ", anchor='e', justify='right',
                font=self.gui.config.police_b,width=labelwidth,)
        l.pack(side="left",expand="yes",fill="both")
        l=Label(f,text=self.niveau1.get(), anchor='w', justify='left',width=entrywidth)
        l.pack(side="left",expand="yes",fill="both")
        if self.niveau2.get()!='':
            f=Frame(g.interior())
            f.pack(side="top",expand="yes",fill="both")
            l=Label(f,text=self.N2+" : ", anchor='e', justify='right',
                    font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(f,text=self.niveau2.get(), anchor='w', justify='left',width=entrywidth)
            l.pack(side="left",expand="yes",fill="both")
        if self.niveau3.get()!='':
            f=Frame(g.interior())
            f.pack(side="top",expand="yes",fill="both")
            l=Label(f,text=self.N3+" : ", anchor='e',justify='right',
                    font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(f,text=self.niveau3.get(), anchor='w', justify='left',width=entrywidth)
            l.pack(side="left",expand="yes",fill="both")        
        if self.niveau4.get()!='':
            f=Frame(g.interior())
            f.pack(side="top",expand="yes",fill="both")
            l=Label(f,text=self.N4+" : ", anchor='e',justify='right',
                    font=self.gui.config.police_b,width=labelwidth,)
            l.pack(side="left",expand="yes",fill="both")
            l=Label(f,text=self.niveau4.get(), anchor='w', justify='left',width=entrywidth)
            l.pack(side="left",expand="yes",fill="both")    

    def AfficherGeneral(self,top):
        labelwidth=22
        entrywidth=17
        wrapwidth=150
        g=Frame(self.hd)
        g.pack(side="top",padx = 5, pady = 5,expand='no',anchor='w',fill="none")
        # date
        f=Frame(g)
        f.pack(side="top",expand="yes",fill="x")
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='x')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='x')
        l=Label(fg,text="Date :",anchor='e',font=self.gui.config.police_b,width=labelwidth)
        l.pack(side='top',expand='yes',fill='x')
        l=Label(fd,text=self.date.get(),anchor='w',width=entrywidth)
        l.pack(side='top',expand='yes',fill='x')
        # Media
        f=Frame(g)
        f.pack(side="top",expand="yes",fill="x")
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='x')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='x')
        l=Label(fg,text="Mdia :",anchor='e',font=self.gui.config.police_b,width=labelwidth)
        l.pack(side='top',expand='yes',fill='x')
        l=Label(fd,text=self.media.get(),anchor='w',width=entrywidth)
        l.pack(side='top',expand='yes',fill='x')
        # Type
        f=Frame(g)
        f.pack(side="top",expand="yes",fill="x")
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='x')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='x')
        l=Label(fg,text="Type de photo :",anchor='e',font=self.gui.config.police_b,width=labelwidth)
        l.pack(side='top',expand='yes',fill='x')
        l=Label(fd,text=self.type.get(),anchor='w',width=entrywidth)
        l.pack(side='top',expand='yes',fill='x')
        #Sauvegarde
        f=Frame(g)
        f.pack(side="top",expand="yes",fill="x")
        fg=Frame(f)
        fg.pack(side='left',expand='yes',fill='x')
        fd=Frame(f)
        fd.pack(side='left',expand='yes',fill='x')
        l=Label(fg,text="Support de sauvegarde :",anchor='e',font=self.gui.config.police_b,width=labelwidth)
        l.pack(side='top',expand='yes',fill='x')
        l=Label(fd,text=self.backup.get(),anchor='w',width=entrywidth)
        l.pack(side='top',expand='yes',fill='x')

    def AfficherComment(self,top):
        self.FormComment(top)
        text=self.comment.get()
        l=Pmw.ScrolledText(self.formcomment.interior(),usehullsize = 1,
                           text_padx=2,
                           hull_width = 269,hull_height=190,scrollmargin=0,
                           text_wrap='word',text_bg='#DDDDDD',
                           )
        l.component('text').config(relief='flat')
        l.pack(side="left",expand="no",fill="none",padx=5,pady=5)
        l.settext(re.sub('<br>','\n',text))
        tools.HTMLFormat(l.component('text'),self.gui.config.police_b,
                         self.gui.config.police_i,self.gui.config.police_u)

    def AfficherBio(self,top,idbio):
        champs=['ID','commun','comment']
        condition=" ID ='"+str(idbio)+"'"
        res=self.db.select('bio',champs,condition)[0]
        g=Pmw.Group(top,tag_text=res[1],tag_font=self.gui.config.police_i)
        g.pack(side="top",padx = 5, pady = 5,expand='yes',anchor='w',fill="x")
        g.component('tag').bind('<ButtonPress-3>',lambda e,id=res[0] :self.PopupMenu(e,id))
        l=Pmw.ScrolledText(g.interior(),
                           text_wrap='word',text_bg='#DDDDDD',usehullsize = 1,
                           hull_width = 730,hull_height=200,
                           )
        l.component('text').config(relief='flat')
        l.pack(side="left",expand="yes",fill="both",padx=10,pady=10)
        l.settext(re.sub('<br>','\n',res[2]))
        tools.HTMLFormat(l.component('text'),self.gui.config.police_b,
                         self.gui.config.police_i,self.gui.config.police_u)

    def PopupMenu(self,e,id):
        self.popup = Menu(self.top, tearoff=0)
        self.popup.add_command(label="Afficher",
                               command=lambda item=id:self.gui.AfficherBio(item))
        self.popup.add_separator()
        self.popup.add_command(label="Supprimer le lien",
                               command=lambda item=id:self.SupprimerLien(item))
        self.popup.post(e.x_root-5, e.y_root-5)
        self.popup.bind("<Leave>",self.FermerPopup)

    def SupprimerLien(self,id):
        self.db.SupprimerLien(id,self.id)

class Photo_Fiche_Modifier(Photo_Fiche_Ajouter):
    """
    Classe de modification des fiches Photo
    """
    def ConvertUnicode(self):
        try:
            self.niveau1.set(unicode(self.niveau1.get(),'latin-1'))
            self.niveau2.set(unicode(self.niveau2.get(),'latin-1'))
            self.niveau3.set(unicode(self.niveau3.get(),'latin-1'))
            self.niveau4.set(unicode(self.niveau4.get(),'latin-1'))
        except:
            pass

    def Afficher(self):
        self.LireFiche()
        self.chemin.set(self.chemin_org.get())
        self.ConvertUnicode()
        Photo_Fiche_Ajouter.Afficher(self)
#        fichier_photo=str(self.chemin.get())+'/'+str(self.fichier.get())
        if os.path.isfile(self.chemin.get()):
            Photo_Fiche_Ajouter.OuvrirPhoto(self,file=self.chemin.get())

    def Sauver(self):
        Photo_Fiche_Ajouter.Sauver(self,Modifier=True)


#========================================================================================= 
# Main
#-----------------------------------------------------------------------------------------
##if __name__ == '__main__':
##    import Tkinter
##    import config,gui,re,os
##    root=Tkinter.Tk()
##    conf=config.Config("./config.xml",root,None)
##    gui= gui.Gui(root,conf)
##    conf.gui=gui
##    # recupere toutes les photo
##    recherche=Photo_Fiche_Rechercher(root,gui)
##    champs=['ID','mer','pays','lieu','site','date','fichier','type_photo',\
##                    'media','sauvegarde','chemin','chemin_org','auteur']
##    res=recherche.db.select('photo',champs,' 1 ')
##    result=[]
##    for item in res:
##        result.append(str(item[0]))
##
##    print len(result)
##    
##    for id in result[350:400]:
##        print '--- '+str(id)+' ---'
##        photo=Photo_Fiche_Modifier(root,gui,str(id))
##        photo.LireFiche()
##        if photo.chemin_org.get()=='':
##            # update la photo
##            photo.chemin.set('/mnt/Plongee/Photos/'+str(re.sub(' ','_',photo.niveau3.get()))+'/'+str(photo.fichier.get()))
##            #photo.chemin.set('Photos/'+str(photo.fichier.get()))
##            # creation photo
##            photo.chemin_org.set(photo.chemin.get())
##            photo.fichier.set(os.path.basename(photo.chemin_org.get()))
##            image=Image.open(photo.chemin_org.get())
##            max_comp=eval(photo.gui.config.photo_comp.get())
##            if photo.gui.config.photo_copier:
##                photo.chemin.set(str(photo.gui.config.photo_rep.get())+'/'+str(photo.fichier.get()))
##            else:
##                photo.chemin.set(photo.chemin_org.get())
##            # generation de la copie local de la photo  
##            max_larg=eval(photo.gui.config.photo_larg.get())
##            max_haut=eval(photo.gui.config.photo_haut.get())
##            size_org=image.size
##            if size_org[0]>max_larg or size_org[1]>max_haut:
##                 image=tools.redim(image,(max_larg,max_haut),alias=True)
##                 try:
##                      image.save(photo.chemin.get(),quality=max_comp,optimize=1)
##                 except IOError: 
##                      image.save(photo.chemin.get(),quality=max_comp)
##            else:
##                 shutil.copyfile(photo.chemin_org.get(),photo.chemin.get())                                                
##            # generation de la miniature
##            mini_larg=eval(photo.gui.config.mini_larg.get())
##            mini_haut=eval(photo.gui.config.mini_haut.get())
##            miniature_path='./miniature/'+str(photo.fichier.get())
##            miniature=tools.redim(image,(mini_larg,mini_haut))
##            try:
##                miniature.save(miniature_path,quality=max_comp,optimize=1)
##            except:
##                miniature.save(miniature_path,quality=max_comp)
##            
##            # update db
##            elements=[]
##            elements.append("chemin_org=\""+tools.nettoyer(photo.chemin_org.get())+"\"")
##            elements.append("chemin=\""+tools.nettoyer(photo.chemin.get())+"\"")
##            res=photo.db.modifier('photo',elements,str(photo.id))
##            photo.db.deconnect()
