# -*- coding: iso8859-1 -*-
#=========================================================================================
#                                                                         
#   This program is a cardware software; you can redistribute it and/or modify
#   it under the terms of the Creative Common Licence defined on :
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================
#                                                                         
#   Ce programme est un cardware, vous pouvez l'utiliser, le modifier et le redistribuer
#   sous les condition dfinies dans la licence Creative Common dont les condition sont
#   dcritent sur
#   http://creativecommons.org/licenses/by-nc-sa/2.0/fr/
#
#   (CC) 2005 by Ronan BOISARD <ronan_boisard@yahoo.com>
#
#=========================================================================================

#=========================================================================================
"""
    classe affichant une bar de progression
"""
#-----------------------------------------------------------------------------------------
__version__ ='0.4'
__author__='Ronan BOISARD <ronan_boisard@yahoo.com>'
#=========================================================================================

import Tkinter

class ProgressBar:
    def __init__(self, Parent, Height=10, Width=200, 
                 ForegroundColor=None,BackgroundColor=None,
                 Progress=0,text='Recherche en cour : '):
        self.Height=Height
        self.Width=Width
        self.titre=Tkinter.Label(Parent,text=text)
	self.titre.pack(side="left")
        self.BarCanvas = Tkinter.Canvas(Parent,
            width=Width,height=Height,
            background='lightblue',borderwidth=1,
            relief=Tkinter.SUNKEN)
        if (BackgroundColor):
            self.BarCanvas["backgroundcolor"]=BackgroundColor
        self.BarCanvas.pack(side='left',padx=5,pady=2)
        self.RectangleID=self.BarCanvas.create_rectangle(0,0,0,Height)
        if (ForegroundColor==None):
            ForegroundColor="darkblue"
        self.BarCanvas.itemconfigure(self.RectangleID,fill=ForegroundColor)
        self.SetProgressPercent(Progress)
        
    def SetProgressPercent(self,NewLevel):
        self.Progress=NewLevel
        self.Progress=min(100,self.Progress)
        self.Progress=max(0,self.Progress)        
        self.DrawProgress()
        
    def DrawProgress(self):
        ProgressPixel=(self.Progress/100.0)*self.Width
        self.BarCanvas.coords(self.RectangleID,
            0,0,ProgressPixel,self.Height)
        
    def GetProgressPercent(self):
        return self.Progress
    
    def destroy(self):
        self.titre.destroy()
        self.BarCanvas.destroy()
